// Generated by LiveScript 1.3.1
(function(){
  var module, test, delay, Promise, timeLimitedPromise, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  delay = core.delay, Promise = core.Promise;
  timeLimitedPromise = function(time, fn){
    return Promise.race([
      new Promise(fn), new Promise(function(res, rej){
        return setTimeout(rej, time);
      })
    ]);
  };
  test('delay', function(assert){
    assert.expect(3);
    assert.ok(toString$.call(delay).slice(8, -1) === 'Function', 'is function');
    assert.ok(delay(42) instanceof Promise, 'returns promises');
    return timeLimitedPromise(1e3, function(res){
      delay(10).then(function(it){
        res(it);
      });
    }).then(function(it){
      return assert.ok(it === true, 'resolves as `true`');
    })['catch'](function(){
      return assert.ok(false, 'rejected');
    }).then(assert.async());
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, Dict, Set, Symbol, ref$, keys, create, assign, make, from, values, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  Dict = core.Dict, Set = core.Set, Symbol = core.Symbol;
  ref$ = core.Object, keys = ref$.keys, create = ref$.create, assign = ref$.assign, make = ref$.make;
  ref$ = core.Array, from = ref$.from, values = ref$.values;
  test('Dict', function(assert){
    var dict1, dict2, dict3, done, iter;
    assert.ok(isFunction(Dict), 'is function');
    dict1 = Dict();
    assert.ok(!(dict1 instanceof Object));
    assert.deepEqual(keys(dict1), []);
    dict2 = Dict({
      q: 1,
      w: 2
    });
    assert.ok(!(dict2 instanceof Object));
    assert.deepEqual(keys(dict2), ['q', 'w']);
    assert.ok(dict2.q === 1);
    assert.ok(dict2.w === 2);
    dict3 = Dict(new Set([1, 2]).entries());
    assert.ok(!(dict3 instanceof Object));
    assert.deepEqual(keys(dict3), ['1', '2']);
    assert.ok(dict3[1] === 1);
    assert.ok(dict3[2] === 2);
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      new Dict(iter);
    } catch (e$) {}
    return assert.ok(done, '.return #throw');
  });
  test('Dict.every', function(assert){
    var every, obj, ctx;
    every = Dict.every;
    assert.ok(isFunction(every), 'is function');
    every(obj = {
      q: 1
    }, function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 'q');
      assert.ok(that === obj);
      return assert.ok(this === ctx);
    }, ctx = {});
    assert.ok(every({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    return assert.ok(!every({
      q: 1,
      w: '2',
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('Dict.filter', function(assert){
    var filter, obj, ctx;
    filter = Dict.filter;
    assert.ok(isFunction(filter), 'is function');
    filter(obj = {
      q: 1
    }, function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 'q');
      assert.ok(that === obj);
      return assert.ok(this === ctx);
    }, ctx = {});
    return assert.deepEqual(filter({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return it % 2;
    }), Dict({
      q: 1,
      e: 3
    }));
  });
  test('Dict.find', function(assert){
    var find, obj, ctx;
    find = Dict.find;
    assert.ok(isFunction(find), 'is function');
    find(obj = {
      q: 1
    }, function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 'q');
      assert.ok(that === obj);
      return assert.ok(this === ctx);
    }, ctx = {});
    return assert.ok(find({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return !(it % 2);
    }) === 2);
  });
  test('Dict.findKey', function(assert){
    var findKey, obj, ctx;
    findKey = Dict.findKey;
    assert.ok(isFunction(findKey), 'is function');
    findKey(obj = {
      q: 1
    }, function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 'q');
      assert.ok(that === obj);
      return assert.ok(this === ctx);
    }, ctx = {});
    return assert.ok(findKey({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return it === 2;
    }) === 'w');
  });
  test('Dict.forEach', function(assert){
    var forEach, obj, ctx, rez;
    forEach = Dict.forEach;
    assert.ok(isFunction(forEach), 'is function');
    forEach(obj = {
      q: 1
    }, function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 'q');
      assert.ok(that === obj);
      assert.ok(this === ctx);
    }, ctx = {});
    rez = {};
    forEach({
      q: 1,
      w: 2
    }, function(){
      rez[arguments[1]] = arguments[0] + this;
    }, '_');
    assert.deepEqual(rez, {
      q: '1_',
      w: '2_'
    });
    rez = true;
    forEach(obj = {
      q: 1,
      w: 2
    }, function(){
      var rez;
      rez && (rez = obj === arguments[2]);
    });
    assert.ok(rez);
    rez = {};
    forEach(make({
      e: 3
    }, {
      q: 1,
      w: 2
    }), function(){
      rez[arguments[1]] = arguments[0];
    });
    assert.ok(!('e' in rez));
    rez = {};
    forEach([1, 2], function(){
      rez[arguments[1]] = arguments[0];
    });
    assert.ok(!('length' in rez));
    rez = {};
    forEach('123', function(){
      rez[arguments[1]] = arguments[0];
    });
    return assert.ok('2' in rez);
  });
  test('Dict.keyOf', function(assert){
    var keyOf;
    keyOf = Dict.keyOf;
    assert.ok(isFunction(keyOf), 'is function');
    assert.ok(keyOf({
      q: 1,
      w: 2,
      e: 3
    }, 2) === 'w');
    assert.ok(keyOf({
      q: 1,
      w: 2,
      e: 3
    }, 4) === void 8);
    return assert.ok(keyOf({
      q: 1,
      w: 2,
      e: NaN
    }, NaN) === void 8);
  });
  test('Dict.map', function(assert){
    var map, obj, ctx;
    map = Dict.map;
    assert.ok(isFunction(map), 'is function');
    map(obj = {
      q: 1
    }, function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 'q');
      assert.ok(that === obj);
      return assert.ok(this === ctx);
    }, ctx = {});
    return assert.deepEqual(map({
      q: 1,
      w: 2,
      e: 3
    }, (function(it){
      return Math.pow(it, 2);
    })), Dict({
      q: 1,
      w: 4,
      e: 9
    }));
  });
  test('Dict.mapPairs', function(assert){
    var mapPairs, obj, ctx;
    mapPairs = Dict.mapPairs;
    assert.ok(isFunction(mapPairs), 'is function');
    mapPairs(obj = {
      q: 1
    }, function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 'q');
      assert.ok(that === obj);
      return assert.ok(this === ctx);
    }, ctx = {});
    return assert.deepEqual(mapPairs({
      q: 1,
      w: 2,
      e: 3
    }, function(v, k){
      return v !== 2 && [k + k, v * v];
    }), Dict({
      qq: 1,
      ee: 9
    }));
  });
  test('Dict.reduce', function(assert){
    var reduce, obj, foo, memo;
    reduce = Dict.reduce;
    assert.ok(isFunction(reduce), 'is function');
    reduce(obj = {
      a: 1
    }, function(memo, val, key, that){
      assert.ok(memo === foo);
      assert.ok(val === 1);
      assert.ok(key === 'a');
      return assert.ok(that === obj);
    }, foo = {});
    reduce({
      a: 1,
      b: 2
    }, function(memo, val, key){
      assert.ok(memo === 1);
      assert.ok(val === 2);
      return assert.ok(key === 'b');
    });
    reduce({
      q: 1,
      w: 2,
      e: 3
    }, function(that, it){
      that[it] = it;
      return that;
    }, memo = {});
    return assert.deepEqual(memo, {
      1: 1,
      2: 2,
      3: 3
    });
  });
  test('Dict.some', function(assert){
    var some, obj, ctx;
    some = Dict.some;
    assert.ok(isFunction(some), 'is function');
    some(obj = {
      q: 1
    }, function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 'q');
      assert.ok(that === obj);
      return assert.ok(this === ctx);
    }, ctx = {});
    assert.ok(!some({
      q: 1,
      w: 2,
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    return assert.ok(some({
      q: 1,
      w: '2',
      e: 3
    }, function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
  });
  test('Dict.includes', function(assert){
    var includes, dict, o;
    includes = Dict.includes;
    assert.ok(isFunction(includes), 'is function');
    dict = {
      q: 1,
      w: NaN,
      e: -0,
      r: o = {}
    };
    assert.ok(includes(dict, 1));
    assert.ok(includes(dict, -0));
    assert.ok(includes(dict, 0));
    assert.ok(includes(dict, NaN));
    assert.ok(includes(dict, o));
    assert.ok(!includes(dict, 4));
    assert.ok(!includes(dict, -0.5));
    return assert.ok(!includes(dict, {}));
  });
  test('Dict.has', function(assert){
    var has;
    has = Dict.has;
    assert.ok(isFunction(has), 'is function');
    assert.ok(has({
      q: 1
    }, 'q'));
    assert.ok(!has({
      q: 1
    }, 'w'));
    assert.ok(has([1], 0));
    assert.ok(!has([], 0));
    assert.ok(!has(clone$({
      q: 1
    }), 'q'));
    return assert.ok(!has({}, 'toString'));
  });
  test('Dict.get', function(assert){
    var get;
    get = Dict.get;
    assert.ok(isFunction(get), 'is function');
    assert.ok(get({
      q: 1
    }, 'q') === 1);
    assert.ok(get({
      q: 1
    }, 'w') === void 8);
    assert.ok(get([1], 0) === 1);
    assert.ok(get([], 0) === void 8);
    assert.ok(get(clone$({
      q: 1
    }), 'q') === void 8);
    return assert.ok(get({}, 'toString') === void 8);
  });
  test('Dict.values', function(assert){
    var values, iter;
    values = Dict.values;
    assert.ok(isFunction(values), 'is function');
    iter = values({});
    assert.ok(iter[Symbol != null ? Symbol.toStringTag : void 8] === 'Dict Iterator');
    assert.ok('next' in iter);
    assert.deepEqual(from(values({
      q: 1,
      w: 2,
      e: 3
    })), [1, 2, 3]);
    assert.deepEqual(from(values(new String('qwe'))), ['q', 'w', 'e']);
    return assert.deepEqual(from(values(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    }))), [4, 5, 6]);
  });
  test('Dict.keys', function(assert){
    var keys, iter;
    keys = Dict.keys;
    assert.ok(isFunction(keys), 'is function');
    iter = keys({});
    assert.ok(iter[Symbol != null ? Symbol.toStringTag : void 8] === 'Dict Iterator');
    assert.ok('next' in iter);
    assert.deepEqual(from(keys({
      q: 1,
      w: 2,
      e: 3
    })), ['q', 'w', 'e']);
    assert.deepEqual(from(keys(new String('qwe'))), ['0', '1', '2']);
    return assert.deepEqual(from(keys(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    }))), ['a', 's', 'd']);
  });
  test('Dict.entries', function(assert){
    var entries, iter;
    entries = Dict.entries;
    assert.ok(isFunction(entries), 'is function');
    iter = entries({});
    assert.ok(iter[Symbol != null ? Symbol.toStringTag : void 8] === 'Dict Iterator');
    assert.ok('next' in iter);
    assert.deepEqual(from(entries({
      q: 1,
      w: 2,
      e: 3
    })), [['q', 1], ['w', 2], ['e', 3]]);
    assert.deepEqual(from(entries(new String('qwe'))), [['0', 'q'], ['1', 'w'], ['2', 'e']]);
    return assert.deepEqual(from(entries(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    }))), [['a', 4], ['s', 5], ['d', 6]]);
  });
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, ref$, map, every, reduce, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  ref$ = core.Array, map = ref$.map, every = ref$.every, reduce = ref$.reduce;
  test('Function#part', function(assert){
    var part, $, obj, fn, p;
    part = core.Function.part;
    $ = core._;
    assert.ok(isFunction(part), 'is function');
    assert.ok(part(function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }, 'qwe')());
    obj = {
      a: 42
    };
    obj.fn = part(function(it){
      return this.a + it;
    }, 21);
    assert.ok(obj.fn() === 63);
    fn = function(){
      return map(arguments, String).join(' ');
    };
    p = part(fn, $, 'Саша', $, 'шоссе', $, 'сосала');
    assert.ok(isFunction(p), '.part with placeholders return function');
    assert.ok(p('Шла', 'по') === 'Шла Саша по шоссе undefined сосала', '.part with placeholders: args < placeholders');
    assert.ok(p('Шла', 'по', 'и') === 'Шла Саша по шоссе и сосала', '.part with placeholders: args == placeholders');
    return assert.ok(p('Шла', 'по', 'и', 'сушку') === 'Шла Саша по шоссе и сосала сушку', '.part with placeholders: args > placeholders');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, ref$, from, values;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  ref$ = core.Array, from = ref$.from, values = ref$.values;
  test('core.getIteratorMethod', function(assert){
    var getIteratorMethod, iterFn, iter;
    getIteratorMethod = core.getIteratorMethod;
    assert.ok(typeof getIteratorMethod === 'function', 'is function');
    assert.strictEqual(getIteratorMethod({}), void 8);
    iterFn = getIteratorMethod([]);
    assert.ok(typeof iterFn === 'function');
    iter = iterFn.call([]);
    assert.ok('next' in iter);
    iter = getIteratorMethod(function(){
      return arguments;
    }());
    return assert.ok(typeof iterFn === 'function');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, ref$, from, values;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  ref$ = core.Array, from = ref$.from, values = ref$.values;
  test('core.getIterator', function(assert){
    var getIterator, iter;
    getIterator = core.getIterator;
    assert.ok(typeof getIterator === 'function', 'is function');
    assert.throws(function(){
      getIterator({});
    }, TypeError);
    iter = getIterator([]);
    assert.ok('next' in iter);
    iter = getIterator(function(){
      return arguments;
    }());
    return assert.ok('next' in iter);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, values;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  values = core.Array.values;
  test('core.isIterable', function(assert){
    var isIterable;
    isIterable = core.isIterable;
    assert.ok(typeof isIterable === 'function', 'is function');
    assert.ok(!isIterable({}));
    assert.ok(isIterable([]));
    return assert.ok(isIterable(function(){
      return arguments;
    }()));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, isObject, log, methods, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isObject = function(it){
    return it === Object(it);
  };
  log = core.log;
  methods = ['assert', 'count', 'debug', 'dir', 'dirxml', 'error', 'exception', 'group', 'groupEnd', 'groupCollapsed', 'groupEnd', 'info', 'log', 'table', 'trace', 'warn', 'markTimeline', 'profile', 'profileEnd', 'time', 'timeEnd', 'timeStamp'];
  test('is object', function(assert){
    return assert.ok(isObject(log), 'global.log is object');
  });
  test('log.{..} are functions', function(assert){
    var i$, x$, ref$, len$, results$ = [];
    for (i$ = 0, len$ = (ref$ = methods).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      results$.push(assert.ok(isFunction(log[x$]), "log." + x$ + " is function"));
    }
    return results$;
  });
  test('call log.{..}', function(assert){
    var i$, ref$, len$, m, results$ = [];
    for (i$ = 0, len$ = (ref$ = methods).length; i$ < len$; ++i$) {
      m = ref$[i$];
      results$.push(assert.ok((fn$()), "call log." + m));
    }
    return results$;
    function fn$(){
      try {
        if (m === 'profileEnd') {
          log[m]();
        } else {
          log[m]('foo');
        }
        return true;
      } catch (e$) {}
    }
  });
  test('call unbound log.#{..}', function(assert){
    var i$, ref$, len$, m, results$ = [];
    for (i$ = 0, len$ = (ref$ = methods).length; i$ < len$; ++i$) {
      m = ref$[i$];
      results$.push(assert.ok((fn$()), "call unbound log." + m));
    }
    return results$;
    function fn$(){
      try {
        if (m === 'profileEnd') {
          log[m].call(void 8);
        } else {
          log[m].call(void 8, 'foo');
        }
        return true;
      } catch (e$) {}
    }
  });
  test('log.{enable, disable}', function(assert){
    var enable, disable;
    enable = log.enable, disable = log.disable;
    assert.ok(isFunction(enable), 'log.enable is function');
    assert.ok(isFunction(disable), 'log.disable is function');
    assert.ok((function(){
      try {
        disable();
        return true;
      } catch (e$) {}
    }()), 'disable log');
    assert.ok((function(){
      try {
        return log.log('call disabled log') === void 8;
      } catch (e$) {}
    }()), 'call disabled log');
    return assert.ok((function(){
      try {
        enable();
        return true;
      } catch (e$) {}
    }()), 'enable log');
  });
  test('log', function(assert){
    assert.ok(isFunction(log), 'global.log is function');
    return assert.ok((function(){
      try {
        log(42);
        return true;
      } catch (e$) {}
    }()), 'call log');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  test('Number#@@iterator', function(assert){
    var getIterator, toStringTag, iter1, iter2, iter3, iter4, iter5, iter6;
    getIterator = core.getIterator;
    toStringTag = core.Symbol.toStringTag;
    iter1 = getIterator(2);
    assert.ok(iter1[toStringTag] === 'Number Iterator', '@@toStringTag');
    assert.deepEqual(iter1.next(), {
      done: false,
      value: 0
    }, '2 #1');
    assert.deepEqual(iter1.next(), {
      done: false,
      value: 1
    }, '2 #2');
    assert.deepEqual(iter1.next(), {
      done: true,
      value: void 8
    }, '2 #3');
    iter2 = getIterator(1.5);
    assert.deepEqual(iter2.next(), {
      done: false,
      value: 0
    }, '1.5 #1');
    assert.deepEqual(iter2.next(), {
      done: false,
      value: 1
    }, '1.5 #2');
    assert.deepEqual(iter2.next(), {
      done: true,
      value: void 8
    }, '1.5 #3');
    iter3 = getIterator(-1);
    assert.deepEqual(iter3.next(), {
      done: true,
      value: void 8
    }, '-1');
    iter4 = getIterator(NaN);
    assert.deepEqual(iter4.next(), {
      done: true,
      value: void 8
    }, 'NaN');
    iter5 = getIterator(Infinity);
    assert.deepEqual(iter5.next(), {
      done: false,
      value: 0
    }, 'Infinity #1');
    assert.deepEqual(iter5.next(), {
      done: false,
      value: 1
    }, 'Infinity #1');
    assert.deepEqual(iter5.next(), {
      done: false,
      value: 2
    }, 'Infinity #1');
    iter6 = getIterator(-Infinity);
    return assert.deepEqual(iter6.next(), {
      done: true,
      value: void 8
    }, '-Infinity');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  test('Object.classof', function(assert){
    var classof, Class;
    classof = core.Object.classof;
    assert.ok(toString$.call(classof).slice(8, -1) === 'Function', 'is function');
    assert.ok(classof(void 8) === 'Undefined', 'classof undefined is `Undefined`');
    assert.ok(classof(null) === 'Null', 'classof null is `Null`');
    assert.ok(classof(true) === 'Boolean', 'classof bool is `Boolean`');
    assert.ok(classof('string') === 'String', 'classof string is `String`');
    assert.ok(classof(7) === 'Number', 'classof number is `Number`');
    assert.ok(classof(core.Symbol()) === 'Symbol', 'classof symbol is `Symbol`');
    assert.ok(classof(new Boolean(false)) === 'Boolean', 'classof new Boolean is `Boolean`');
    assert.ok(classof(new String('')) === 'String', 'classof new String is `String`');
    assert.ok(classof(new Number(7)) === 'Number', 'classof new Number is `Number`');
    assert.ok(classof({}) === 'Object', 'classof {} is `Object`');
    assert.ok(classof([]) === 'Array', 'classof array is `Array`');
    assert.ok(classof(function(){}) === 'Function', 'classof function is `Function`');
    assert.ok(classof(/./) === 'RegExp', 'classof regexp is `Undefined`');
    assert.ok(classof(TypeError()) === 'Error', 'classof new TypeError is `RegExp`');
    assert.ok(classof(function(){
      return arguments;
    }()) === 'Arguments', 'classof arguments list is `Arguments`');
    assert.ok(classof(new core.Set) === 'Set', 'classof undefined is `Map`');
    assert.ok(classof(new core.Map) === 'Map', 'classof map is `Undefined`');
    assert.ok(classof(new core.WeakSet) === 'WeakSet', 'classof weakset is `WeakSet`');
    assert.ok(classof(new core.WeakMap) === 'WeakMap', 'classof weakmap is `WeakMap`');
    assert.ok(classof(new core.Promise(function(){})) === 'Promise', 'classof promise is `Promise`');
    assert.ok(classof(core.getIterator('')) === 'String Iterator', 'classof String Iterator is `String Iterator`');
    assert.ok(classof(core.getIterator([])) === 'Array Iterator', 'classof Array Iterator is `Array Iterator`');
    assert.ok(classof(new core.Set().entries()) === 'Set Iterator', 'classof Set Iterator is `Set Iterator`');
    assert.ok(classof(new core.Map().entries()) === 'Map Iterator', 'classof Map Iterator is `Map Iterator`');
    assert.ok(classof(Math) === 'Math', 'classof Math is `Math`');
    if (typeof JSON != 'undefined' && JSON !== null) {
      assert.ok(classof(JSON) === 'JSON', 'classof JSON is `JSON`');
    }
    Class = (function(){
      Class.displayName = 'Class';
      var prototype = Class.prototype, constructor = Class;
      Class.prototype[core.Symbol.toStringTag] = 'Class';
      function Class(){}
      return Class;
    }());
    return assert.ok(classof(new Class) === 'Class', 'classof user class is [Symbol.toStringTag]');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  test('Object.define', function(assert){
    var ref$, define, defineProperty, foo, foo2;
    ref$ = core.Object, define = ref$.define, defineProperty = ref$.defineProperty;
    assert.ok(toString$.call(define).slice(8, -1) === 'Function', 'is function');
    foo = {
      q: 1
    };
    assert.ok(foo === define(foo, {
      w: 2
    }));
    assert.ok(foo.w === 2);
    if (function(){
      try {
        return 2 === defineProperty({}, 'a', {
          get: function(){
            return 2;
          }
        }).a;
      } catch (e$) {}
    }()) {
      foo = {
        q: 1
      };
      foo2 = defineProperty({}, 'w', {
        get: function(){
          return this.q + 1;
        }
      });
      define(foo, foo2);
      return assert.ok(foo.w === 2);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  test('Object.isObject', function(assert){
    var isObject;
    isObject = core.Object.isObject;
    assert.ok(toString$.call(isObject).slice(8, -1) === 'Function', 'is function');
    assert.ok(!isObject(void 8), 'isObject undefined return false');
    assert.ok(!isObject(null), 'isObject null return false');
    assert.ok(!isObject(1), 'isObject number return false');
    assert.ok(!isObject(true), 'isObject bool return false');
    assert.ok(!isObject('string'), 'isObject string return false');
    assert.ok(isObject(new Number(1)), 'isObject new Number return true');
    assert.ok(isObject(new Boolean(false)), 'isObject new Boolean return true');
    assert.ok(isObject(new String(1)), 'isObject new String return true');
    assert.ok(isObject({}), 'isObject object return true');
    assert.ok(isObject([]), 'isObject array return true');
    assert.ok(isObject(/./), 'isObject regexp return true');
    assert.ok(isObject(function(){}), 'isObject function return true');
    return assert.ok(isObject(new function(){}), 'isObject constructor instance return true');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  test('Object.make', function(assert){
    var make, object, foo;
    make = core.Object.make;
    assert.ok(toString$.call(make).slice(8, -1) === 'Function', 'is function');
    object = make(foo = {
      q: 1
    }, {
      w: 2
    });
    assert.ok(core.Object.getPrototypeOf(object) === foo);
    return assert.ok(object.w === 2);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  test('String#escapeHTML', function(assert){
    var escapeHTML;
    escapeHTML = core.String.escapeHTML;
    assert.ok(toString$.call(escapeHTML).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(escapeHTML('qwe, asd'), 'qwe, asd');
    assert.strictEqual(escapeHTML('<div>qwe</div>'), '&lt;div&gt;qwe&lt;/div&gt;');
    return assert.strictEqual(escapeHTML("&<>\"'"), '&amp;&lt;&gt;&quot;&apos;');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('core-js');
  test('String#unescapeHTML', function(assert){
    var unescapeHTML;
    unescapeHTML = core.String.unescapeHTML;
    assert.ok(toString$.call(unescapeHTML).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(unescapeHTML('qwe, asd'), 'qwe, asd');
    assert.strictEqual(unescapeHTML('&lt;div&gt;qwe&lt;/div&gt;'), '<div>qwe</div>');
    return assert.strictEqual(unescapeHTML('&amp;&lt;&gt;&quot;&apos;'), "&<>\"'");
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES5');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  test('Object.getOwnPropertyDescriptor', function(assert){
    var getOwnPropertyDescriptor;
    getOwnPropertyDescriptor = core.Object.getOwnPropertyDescriptor;
    assert.ok(isFunction(getOwnPropertyDescriptor), 'is function');
    assert.deepEqual(getOwnPropertyDescriptor({
      q: 42
    }, 'q'), {
      writable: true,
      enumerable: true,
      configurable: true,
      value: 42
    });
    return assert.ok(getOwnPropertyDescriptor({}, 'toString') === void 8);
  });
  test('Object.defineProperty', function(assert){
    var defineProperty, rez, src;
    defineProperty = core.Object.defineProperty;
    assert.ok(isFunction(defineProperty), 'is function');
    assert.ok((rez = defineProperty(src = {}, 'q', {
      value: 42
    })) === src);
    return assert.ok(rez.q === 42);
  });
  test('Object.defineProperties', function(assert){
    var defineProperties, rez, src;
    defineProperties = core.Object.defineProperties;
    assert.ok(isFunction(defineProperties), 'is function');
    assert.ok((rez = defineProperties(src = {}, {
      q: {
        value: 42
      },
      w: {
        value: 33
      }
    })) === src);
    return assert.ok(rez.q === 42) && rez.w === 33;
  });
  test('Object.getPrototypeOf', function(assert){
    var ref$, create, getPrototypeOf, fn, obj, foo, bar;
    ref$ = core.Object, create = ref$.create, getPrototypeOf = ref$.getPrototypeOf;
    assert.ok(isFunction(getPrototypeOf), 'is function');
    assert.ok(getPrototypeOf({}) === Object.prototype);
    assert.ok(getPrototypeOf([]) === Array.prototype);
    assert.ok(getPrototypeOf(new (fn = (function(){
      fn.displayName = 'fn';
      var prototype = fn.prototype, constructor = fn;
      function fn(){}
      return fn;
    }()))) === fn.prototype);
    assert.ok(getPrototypeOf(create(obj = {
      q: 1
    })) === obj);
    assert.ok(getPrototypeOf(create(null)) === null);
    assert.ok(getPrototypeOf(getPrototypeOf({})) === null);
    foo = function(){};
    foo.prototype.foo = 'foo';
    bar = function(){};
    bar.prototype = create(foo.prototype);
    bar.prototype.constructor = bar;
    return assert.strictEqual(getPrototypeOf(bar.prototype).foo, 'foo');
  });
  test('Object.getOwnPropertyNames', function(assert){
    var getOwnPropertyNames, fn1, fn2, names;
    getOwnPropertyNames = core.Object.getOwnPropertyNames;
    assert.ok(isFunction(getOwnPropertyNames), 'is function');
    fn1 = function(w){
      this.w = w != null ? w : 2;
    };
    fn2 = function(toString){
      this.toString = toString != null ? toString : 2;
    };
    fn1.prototype.q = fn2.prototype.q = 1;
    names = getOwnPropertyNames([1, 2, 3]);
    assert.strictEqual(names.length, 4);
    assert.ok(in$('0', names));
    assert.ok(in$('1', names));
    assert.ok(in$('2', names));
    assert.ok(in$('length', names));
    assert.deepEqual(getOwnPropertyNames(new fn1(1)), ['w']);
    assert.deepEqual(getOwnPropertyNames(new fn2(1)), ['toString']);
    assert.ok(in$('toString', getOwnPropertyNames(Array.prototype)));
    assert.ok(in$('toString', getOwnPropertyNames(Object.prototype)));
    return assert.ok(in$('constructor', getOwnPropertyNames(Object.prototype)));
  });
  test('Object.create', function(assert){
    var ref$, create, getPrototypeOf, getOwnPropertyNames, isObject, isPrototype, getPropertyNames, obj, fn;
    ref$ = core.Object, create = ref$.create, getPrototypeOf = ref$.getPrototypeOf, getOwnPropertyNames = ref$.getOwnPropertyNames;
    isObject = function(it){
      return it === Object(it);
    };
    isPrototype = function(a, b){
      return {}.isPrototypeOf.call(a, b);
    };
    getPropertyNames = function(object){
      var result, i$, x$, ref$, len$;
      result = getOwnPropertyNames(object);
      while (object = getPrototypeOf(object)) {
        for (i$ = 0, len$ = (ref$ = getOwnPropertyNames(object)).length; i$ < len$; ++i$) {
          x$ = ref$[i$];
          in$(x$, result) || result.push(x$);
        }
      }
      return result;
    };
    assert.ok(isFunction(create), 'is function');
    assert.ok(isPrototype(obj = {
      q: 1
    }, create(obj)));
    assert.ok(create(obj).q === 1);
    fn = function(){
      return this.a = 1;
    };
    assert.ok(create(new fn) instanceof fn);
    assert.ok(fn.prototype === getPrototypeOf(getPrototypeOf(create(new fn))));
    assert.ok(create(new fn).a === 1);
    assert.ok(create({}, {
      a: {
        value: 42
      }
    }).a === 42);
    assert.ok(isObject(obj = create(null, {
      w: {
        value: 2
      }
    })));
    assert.ok(!('toString' in obj));
    assert.ok(obj.w === 2);
    return assert.deepEqual(getPropertyNames(create(null)), []);
  });
  test('Object.keys', function(assert){
    var keys, fn1, fn2;
    keys = core.Object.keys;
    assert.ok(isFunction(keys), 'is function');
    fn1 = function(w){
      this.w = w != null ? w : 2;
    };
    fn2 = function(toString){
      this.toString = toString != null ? toString : 2;
    };
    fn1.prototype.q = fn2.prototype.q = 1;
    assert.deepEqual(keys([1, 2, 3]), ['0', '1', '2']);
    assert.deepEqual(keys(new fn1(1)), ['w']);
    assert.deepEqual(keys(new fn2(1)), ['toString']);
    return assert.ok(!in$('push', keys(Array.prototype)));
  });
  test('Object.seal', function(assert){
    var seal, a;
    seal = core.Object.seal;
    assert.ok(isFunction(seal), 'is function');
    return assert.strictEqual(seal(a = {}), a);
  });
  test('Object.freeze', function(assert){
    var freeze, a;
    freeze = core.Object.freeze;
    assert.ok(isFunction(freeze), 'is function');
    return assert.strictEqual(freeze(a = {}), a);
  });
  test('Object.preventExtensions', function(assert){
    var preventExtensions, a;
    preventExtensions = core.Object.preventExtensions;
    assert.ok(isFunction(preventExtensions), 'is function');
    return assert.strictEqual(preventExtensions(a = {}), a);
  });
  test('Object.isSealed', function(assert){
    var isSealed;
    isSealed = core.Object.isSealed;
    assert.ok(isFunction(isSealed), 'is function');
    return assert.strictEqual(isSealed({}), false);
  });
  test('Object.isFrozen', function(assert){
    var isFrozen;
    isFrozen = core.Object.isFrozen;
    assert.ok(isFunction(isFrozen), 'is function');
    return assert.strictEqual(isFrozen({}), false);
  });
  test('Object.isExtensible', function(assert){
    var isExtensible;
    isExtensible = core.Object.isExtensible;
    assert.ok(isFunction(isExtensible), 'is function');
    return assert.strictEqual(isExtensible({}), true);
  });
  test('Function#bind', function(assert){
    var bind, obj, fn, inst, F, date;
    bind = core.Function.bind;
    assert.ok(isFunction(bind), 'is function');
    obj = {
      a: 42
    };
    assert.ok(42 === bind(function(){
      return this.a;
    }, obj)());
    assert.ok(void 8 === new (bind(function(){}, obj))().a);
    fn = function(a, b){
      this.a = a;
      this.b = b;
    };
    inst = new (bind(fn, null, 1))(2);
    assert.ok(inst instanceof fn);
    assert.strictEqual(inst.a, 1);
    assert.strictEqual(inst.b, 2);
    assert.ok(42 === bind(function(it){
      return it;
    }, null, 42)());
    fn = bind(RegExp.prototype.test, /a/);
    assert.ok(fn('a'));
    F = bind(Date, null, 2015);
    date = new F(6);
    assert.ok(date instanceof Date);
    assert.strictEqual(date.getFullYear(), 2015);
    return assert.strictEqual(date.getMonth(), 6);
  });
  test('Array.isArray', function(assert){
    var isArray;
    isArray = core.Array.isArray;
    assert.ok(isFunction(isArray), 'is function');
    assert.ok(!isArray({}));
    assert.ok(!isArray(function(){
      return arguments;
    }()));
    return assert.ok(isArray([]));
  });
  test('ES5 Array prototype methods are functions', function(assert){
    var i$, x$, ref$, len$, results$ = [];
    for (i$ = 0, len$ = (ref$ = ['indexOf', 'lastIndexOf', 'every', 'some', 'forEach', 'map', 'filter', 'reduce', 'reduceRight']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      results$.push(assert.ok(isFunction(core.Array[x$]), "Array::" + x$ + " is function"));
    }
    return results$;
  });
  test('Array#slice', function(assert){
    var slice, arr, str, list, ref$, e;
    slice = core.Array.slice;
    arr = ['1', '2', '3', '4', '5'];
    assert.deepEqual(slice(arr), arr);
    assert.deepEqual(slice(arr, 1, 3), ['2', '3']);
    assert.deepEqual(slice(arr, 1, void 8), ['2', '3', '4', '5']);
    assert.deepEqual(slice(arr, 1, -1), ['2', '3', '4']);
    assert.deepEqual(slice(arr, -2, -1), ['4']);
    assert.deepEqual(slice(arr, -2, -3), []);
    str = '12345';
    assert.deepEqual(slice(str), arr);
    assert.deepEqual(slice(str, 1, 3), ['2', '3']);
    assert.deepEqual(slice(str, 1, void 8), ['2', '3', '4', '5']);
    assert.deepEqual(slice(str, 1, -1), ['2', '3', '4']);
    assert.deepEqual(slice(str, -2, -1), ['4']);
    assert.deepEqual(slice(str, -2, -3), []);
    if (list = typeof document != 'undefined' && document !== null ? (ref$ = document.body) != null ? ref$.childNodes : void 8 : void 8) {
      try {
        return assert.strictEqual(toString$.call(slice(list)).slice(8, -1), 'Array');
      } catch (e$) {
        e = e$;
        return assert.ok(false);
      }
    }
  });
  test('Array#join', function(assert){
    var join;
    join = core.Array.join;
    assert.strictEqual(join('123'), '1,2,3');
    return assert.strictEqual(join('123', '|'), '1|2|3');
  });
  test('Array#indexOf', function(assert){
    var indexOf;
    indexOf = core.Array.indexOf;
    assert.ok(0 === indexOf([1, 1, 1], 1));
    assert.ok(-1 === indexOf([1, 2, 3], 1, 1));
    assert.ok(1 === indexOf([1, 2, 3], 2, 1));
    assert.ok(-1 === indexOf([NaN], NaN));
    assert.ok(3 === indexOf(Array(2).concat([1, 2, 3]), 2));
    return assert.ok(-1 === indexOf(Array(1), void 8));
  });
  test('Array#lastIndexOf', function(assert){
    var lastIndexOf;
    lastIndexOf = core.Array.lastIndexOf;
    assert.strictEqual(2, lastIndexOf([1, 1, 1], 1));
    assert.strictEqual(-1, lastIndexOf([1, 2, 3], 3, 1));
    assert.strictEqual(1, lastIndexOf([1, 2, 3], 2, 1));
    assert.strictEqual(-1, lastIndexOf([NaN], NaN));
    return assert.strictEqual(1, lastIndexOf([1, 2, 3].concat(Array(2)), 2));
  });
  test('Array#every', function(assert){
    var every, a, ctx, rez, arr;
    every = core.Array.every;
    every(a = [1], function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 0);
      assert.ok(that === a);
      return assert.ok(this === ctx);
    }, ctx = {});
    assert.ok(every([1, 2, 3], function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    assert.ok(every([1, 2, 3], (function(it){
      return it < 4;
    })));
    assert.ok(!every([1, 2, 3], (function(it){
      return it < 3;
    })));
    assert.ok(!every([1, 2, 3], function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    assert.ok(every([1, 2, 3], function(){
      return +this === 1;
    }, 1));
    rez = '';
    every([1, 2, 3], function(){
      return rez += arguments[1];
    });
    assert.ok(rez === '012');
    return assert.ok(every(arr = [1, 2, 3], function(){
      return arguments[2] === arr;
    }));
  });
  test('Array#some', function(assert){
    var some, a, ctx, rez, arr;
    some = core.Array.some;
    some(a = [1], function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 0);
      assert.ok(that === a);
      return assert.ok(this === ctx);
    }, ctx = {});
    assert.ok(some([1, '2', 3], function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    assert.ok(some([1, 2, 3], (function(it){
      return it < 3;
    })));
    assert.ok(!some([1, 2, 3], (function(it){
      return it < 0;
    })));
    assert.ok(!some([1, 2, 3], function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    assert.ok(!some([1, 2, 3], function(){
      return +this !== 1;
    }, 1));
    rez = '';
    some([1, 2, 3], function(){
      rez += arguments[1];
      return false;
    });
    assert.ok(rez === '012');
    return assert.ok(!some(arr = [1, 2, 3], function(){
      return arguments[2] !== arr;
    }));
  });
  test('Array#forEach', function(assert){
    var forEach, a, ctx, rez, arr;
    forEach = core.Array.forEach;
    forEach(a = [1], function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 0);
      assert.ok(that === a);
      assert.ok(this === ctx);
    }, ctx = {});
    rez = '';
    forEach([1, 2, 3], function(it){
      rez += it;
    });
    assert.ok(rez === '123');
    rez = '';
    forEach([1, 2, 3], function(){
      rez += arguments[1];
    });
    assert.ok(rez === '012');
    rez = '';
    forEach([1, 2, 3], function(){
      rez += arguments[2];
    });
    assert.ok(rez === '1,2,31,2,31,2,3');
    rez = '';
    forEach([1, 2, 3], function(){
      rez += this;
    }, 1);
    assert.ok(rez === '111');
    rez = '';
    arr = [];
    arr[5] = '';
    forEach(arr, function(arg$, k){
      rez += k;
    });
    return assert.ok(rez === '5');
  });
  test('Array#map', function(assert){
    var map, a, ctx;
    map = core.Array.map;
    map(a = [1], function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 0);
      assert.ok(that === a);
      return assert.ok(this === ctx);
    }, ctx = {});
    assert.deepEqual([2, 3, 4], map([1, 2, 3], (function(it){
      return it + 1;
    })));
    assert.deepEqual([1, 3, 5], map([1, 2, 3], curry$(function(x$, y$){
      return x$ + y$;
    })));
    return assert.deepEqual([2, 2, 2], map([1, 2, 3], function(){
      return +this;
    }, 2));
  });
  test('Array#filter', function(assert){
    var filter, a, ctx;
    filter = core.Array.filter;
    filter(a = [1], function(val, key, that){
      assert.ok(val === 1);
      assert.ok(key === 0);
      assert.ok(that === a);
      return assert.ok(this === ctx);
    }, ctx = {});
    return assert.deepEqual([1, 2, 3, 4, 5], filter([1, 2, 3, 'q', {}, 4, true, 5], function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('Array#reduce', function(assert){
    var reduce, a;
    reduce = core.Array.reduce;
    assert.ok(-5 === reduce([5, 4, 3, 2, 1], curry$(function(x$, y$){
      return x$ - y$;
    })));
    reduce(a = [1], function(memo, val, key, that){
      assert.ok(memo === 42);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === a);
    }, 42);
    return reduce([42, 43], function(it){
      return assert.ok(it === 42);
    });
  });
  test('Array#reduceRight', function(assert){
    var reduceRight, a;
    reduceRight = core.Array.reduceRight;
    assert.ok(-5 === reduceRight([1, 2, 3, 4, 5], curry$(function(x$, y$){
      return x$ - y$;
    })));
    reduceRight(a = [1], function(memo, val, key, that){
      assert.ok(memo === 42);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === a);
    }, 42);
    return reduceRight([42, 43], function(it){
      return assert.ok(it === 43);
    });
  });
  test('Date.now', function(assert){
    var now;
    now = core.Date.now;
    assert.ok(isFunction(now), 'is function');
    return assert.ok(+new Date - now() < 10, 'Date.now() ~ +new Date');
  });
  test('Date#toISOString', function(assert){
    var toISOString, ft, bc;
    toISOString = core.Date.toISOString;
    assert.ok(isFunction(toISOString), 'is function');
    assert.strictEqual(toISOString(new Date(0)), '1970-01-01T00:00:00.000Z');
    assert.strictEqual(toISOString(new Date(1e12 + 1)), '2001-09-09T01:46:40.001Z');
    assert.strictEqual(toISOString(new Date(-5e13 - 1)), '0385-07-25T07:06:39.999Z');
    ft = toISOString(new Date(1e15 + 1));
    assert.ok(ft === '+033658-09-27T01:46:40.001Z' || ft === '33658-09-27T01:46:40.001Z');
    bc = toISOString(new Date(-1e15 + 1));
    assert.ok(bc === '-029719-04-05T22:13:20.001Z' || bc === '-29719-04-05T22:13:20.001Z');
    return assert.throws(function(){
      return toISOString(new Date(NaN));
    }, RangeError);
  });
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Array#copyWithin', function(assert){
    var copyWithin, a;
    copyWithin = core.Array.copyWithin;
    assert.ok(toString$.call(copyWithin).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(a = copyWithin([1], 0), a);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], 0, 3), [4, 5, 3, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], 1, 3), [1, 4, 5, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], 1, 2), [1, 3, 4, 5, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], 2, 2), [1, 2, 3, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], 0, 3, 4), [4, 2, 3, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], 1, 3, 4), [1, 4, 3, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], 1, 2, 4), [1, 3, 4, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], 0, -2), [4, 5, 3, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], 0, -2, -1), [4, 2, 3, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], -4, -3, -2), [1, 3, 3, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], -4, -3, -1), [1, 3, 4, 4, 5]);
    assert.deepEqual(copyWithin([1, 2, 3, 4, 5], -4, -3), [1, 3, 4, 5, 5]);
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return copyWithin(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return copyWithin(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Array#fill', function(assert){
    var fill, a;
    fill = core.Array.fill;
    assert.ok(toString$.call(fill).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(a = fill(Array(5), 5), a);
    assert.deepEqual(fill(Array(5), 5), [5, 5, 5, 5, 5]);
    assert.deepEqual(fill(Array(5), 5, 1), [void 8, 5, 5, 5, 5]);
    assert.deepEqual(fill(Array(5), 5, 1, 4), [void 8, 5, 5, 5, void 8]);
    assert.deepEqual(fill(Array(5), 5, 6, 1), [void 8, void 8, void 8, void 8, void 8]);
    assert.deepEqual(fill(Array(5), 5, -3, 4), [void 8, void 8, 5, 5, void 8]);
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return fill(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return fill(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Array#findIndex', function(assert){
    var findIndex, arr, ctx;
    findIndex = core.Array.findIndex;
    assert.ok(toString$.call(findIndex).slice(8, -1) === 'Function', 'is function');
    findIndex(arr = [1], function(val, key, that){
      assert.strictEqual(this, ctx);
      assert.strictEqual(val, 1);
      assert.strictEqual(key, 0);
      return assert.strictEqual(that, arr);
    }, ctx = {});
    assert.strictEqual(findIndex([1, 3, NaN, 42, {}], (function(it){
      return it === 42;
    })), 3);
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return findIndex(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return findIndex(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Array#find', function(assert){
    var find, arr, ctx;
    find = core.Array.find;
    assert.ok(toString$.call(find).slice(8, -1) === 'Function', 'is function');
    find(arr = [1], function(val, key, that){
      assert.strictEqual(this, ctx);
      assert.strictEqual(val, 1);
      assert.strictEqual(key, 0);
      return assert.strictEqual(that, arr);
    }, ctx = {});
    assert.strictEqual(find([1, 3, NaN, 42, {}], (function(it){
      return it === 42;
    })), 42);
    assert.strictEqual(find([1, 3, NaN, 42, {}], (function(it){
      return it === 43;
    })), void 8);
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return find(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return find(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Array.from', function(assert){
    var ref$, from, values, iterator, al, ctx, done, iter, F, inst, a;
    ref$ = core.Array, from = ref$.from, values = ref$.values;
    iterator = core.Symbol.iterator;
    assert.ok(toString$.call(from).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(from.length, 1, 'arity is 1');
    assert.deepEqual(from('123'), ['1', '2', '3']);
    assert.deepEqual(from({
      length: 3,
      0: 1,
      1: 2,
      2: 3
    }), [1, 2, 3]);
    from(al = function(){
      return arguments;
    }(1), function(val, key){
      assert.strictEqual(this, ctx);
      assert.strictEqual(val, 1);
      return assert.strictEqual(key, 0);
    }, ctx = {});
    from([1], function(val, key){
      assert.strictEqual(this, ctx);
      assert.strictEqual(val, 1);
      return assert.strictEqual(key, 0);
    }, ctx = {});
    assert.deepEqual(from({
      length: 3,
      0: 1,
      1: 2,
      2: 3
    }, (function(it){
      return Math.pow(it, 2);
    })), [1, 4, 9]);
    assert.deepEqual(from(new core.Set([1, 2, 3, 2, 1])), [1, 2, 3], 'Works with iterators');
    assert.throws(function(){
      return from(null);
    }, TypeError);
    assert.throws(function(){
      return from(void 8);
    }, TypeError);
    done = true;
    iter = values([1, 2, 3]);
    iter['return'] = function(){
      return done = false;
    };
    from(iter, function(){
      return false;
    });
    assert.ok(done, '.return #default');
    done = false;
    iter = values([1, 2, 3]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      from(iter, function(){
        throw 42;
      });
    } catch (e$) {}
    assert.ok(done, '.return #throw');
    F = function(){};
    inst = from.call(F, [1, 2]);
    assert.ok(inst instanceof F);
    assert.strictEqual(inst[0], 1);
    assert.strictEqual(inst[1], 2);
    assert.strictEqual(inst.length, 2);
    inst = from.call(F, {
      0: 1,
      1: 2,
      length: 2
    });
    assert.ok(inst instanceof F);
    assert.strictEqual(inst[0], 1);
    assert.strictEqual(inst[1], 2);
    assert.strictEqual(inst.length, 2);
    a = [1, 2, 3];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    assert.deepEqual(from(a), [1, 2, 3]);
    return assert.ok(done);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, isIterator, Symbol, ref$, keys, values, entries, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  Symbol = core.Symbol;
  ref$ = core.Array, keys = ref$.keys, values = ref$.values, entries = ref$.entries;
  test('Array#@@iterator', function(assert){
    var iter;
    assert.ok(isFunction(values), 'is function');
    iter = core.getIterator(['q', 'w', 'e']);
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Array Iterator');
    assert.deepEqual(iter.next(), {
      value: 'q',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'w',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'e',
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Array#keys', function(assert){
    var iter;
    assert.ok(isFunction(keys), 'is function');
    iter = keys(['q', 'w', 'e']);
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Array Iterator');
    assert.deepEqual(iter.next(), {
      value: 0,
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 1,
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 2,
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Array#values', function(assert){
    var iter;
    assert.ok(isFunction(values), 'is function');
    iter = values(['q', 'w', 'e']);
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Array Iterator');
    assert.deepEqual(iter.next(), {
      value: 'q',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'w',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'e',
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Array#entries', function(assert){
    var iter;
    assert.ok(isFunction(entries), 'is function');
    iter = entries(['q', 'w', 'e']);
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Array Iterator');
    assert.deepEqual(iter.next(), {
      value: [0, 'q'],
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: [1, 'w'],
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: [2, 'e'],
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Array.of', function(assert){
    var F, inst;
    assert.ok(toString$.call(core.Array.of).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(core.Array.of.length, 0, 'arity is 0');
    assert.deepEqual(core.Array.of(1), [1]);
    assert.deepEqual(core.Array.of(1, 2, 3), [1, 2, 3]);
    F = function(){};
    inst = core.Array.of.call(F, 1, 2);
    assert.ok(inst instanceof F);
    assert.strictEqual(inst[0], 1);
    assert.strictEqual(inst[1], 2);
    return assert.strictEqual(inst.length, 2);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Function#@@hasInstance', function(assert){
    assert.ok(core.Symbol.hasInstance in Function.prototype);
    assert.ok(Function[core.Symbol.hasInstance](function(){}));
    return assert.ok(!Function[core.Symbol.hasInstance]({}));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, isIterator, same, Map, Symbol, ref$, getOwnPropertyDescriptor, freeze, entries, values, iterator, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  same = function(a, b){
    if (a === b) {
      return a !== 0 || 1 / a === 1 / b;
    } else {
      return a != a && b != b;
    }
  };
  Map = core.Map, Symbol = core.Symbol;
  ref$ = core.Object, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, freeze = ref$.freeze;
  ref$ = core.Array, entries = ref$.entries, values = ref$.values;
  iterator = core.Symbol.iterator;
  test('Map', function(assert){
    var done, iter, a;
    assert.ok(isFunction(Map), 'is function');
    assert.ok('clear' in Map.prototype, 'clear in Map.prototype');
    assert.ok('delete' in Map.prototype, 'delete in Map.prototype');
    assert.ok('forEach' in Map.prototype, 'forEach in Map.prototype');
    assert.ok('get' in Map.prototype, 'get in Map.prototype');
    assert.ok('has' in Map.prototype, 'has in Map.prototype');
    assert.ok('set' in Map.prototype, 'set in Map.prototype');
    assert.ok(new Map instanceof Map, 'new Map instanceof Map');
    assert.strictEqual(new Map(entries([1, 2, 3])).size, 3, 'Init from iterator #1');
    assert.strictEqual(new Map(new Map(entries([1, 2, 3]))).size, 3, 'Init from iterator #2');
    assert.strictEqual(new Map([[freeze({}), 1], [2, 3]]).size, 2, 'Support frozen objects');
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      new Map(iter);
    } catch (e$) {}
    assert.ok(done, '.return #throw');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    new Map(a);
    return assert.ok(done);
  });
  test('Map#clear', function(assert){
    var M, f;
    assert.ok(isFunction(Map.prototype.clear), 'is function');
    M = new Map;
    M.clear();
    assert.strictEqual(M.size, 0);
    M = new Map().set(1, 2).set(2, 3).set(1, 4);
    M.clear();
    assert.strictEqual(M.size, 0);
    assert.ok(!M.has(1));
    assert.ok(!M.has(2));
    M = new Map().set(1, 2).set(f = freeze({}), 3);
    M.clear();
    assert.strictEqual(M.size, 0, 'Support frozen objects');
    assert.ok(!M.has(1));
    return assert.ok(!M.has(f));
  });
  test('Map#delete', function(assert){
    var a, M, f;
    assert.ok(isFunction(Map.prototype['delete']), 'is function');
    a = [];
    M = new Map().set(NaN, 1).set(2, 1).set(3, 1).set(2, 5).set(1, 4).set(a, {});
    assert.strictEqual(M.size, 5);
    assert.ok(M['delete'](NaN));
    assert.strictEqual(M.size, 4);
    assert.ok(!M['delete'](4));
    assert.strictEqual(M.size, 4);
    M['delete']([]);
    assert.strictEqual(M.size, 4);
    M['delete'](a);
    assert.strictEqual(M.size, 3);
    M.set(freeze(f = {}), 42);
    assert.strictEqual(M.size, 4);
    M['delete'](f);
    return assert.strictEqual(M.size, 3);
  });
  test('Map#forEach', function(assert){
    var r, T, count, M, a, map, s;
    assert.ok(isFunction(Map.prototype.forEach), 'is function');
    r = {};
    count = 0;
    M = new Map().set(NaN, 1).set(2, 1).set(3, 7).set(2, 5).set(1, 4).set(a = {}, 9);
    M.forEach(function(value, key){
      count++;
      r[value] = key;
    });
    assert.strictEqual(count, 5);
    assert.deepEqual(r, {
      1: NaN,
      7: 3,
      5: 2,
      4: 1,
      9: a
    });
    map = new Map([['0', 9], ['1', 9], ['2', 9], ['3', 9]]);
    s = "";
    map.forEach(function(value, key){
      s += key;
      if (key === '2') {
        map['delete']('2');
        map['delete']('3');
        map['delete']('1');
        return map.set('4', 9);
      }
    });
    assert.strictEqual(s, '0124');
    map = new Map([['0', 1]]);
    s = "";
    map.forEach(function(it){
      map['delete']('0');
      if (s !== '') {
        throw '!!!';
      }
      return s += it;
    });
    return assert.strictEqual(s, '1');
  });
  test('Map#get', function(assert){
    var o, f, M;
    assert.ok(isFunction(Map.prototype.get), 'is function');
    o = {};
    f = freeze({});
    M = new Map([[NaN, 1], [2, 1], [3, 1], [2, 5], [1, 4], [f, 42], [o, o]]);
    assert.strictEqual(M.get(NaN), 1);
    assert.strictEqual(M.get(4), void 8);
    assert.strictEqual(M.get({}), void 8);
    assert.strictEqual(M.get(o), o);
    assert.strictEqual(M.get(f), 42);
    return assert.strictEqual(M.get(2), 5);
  });
  test('Map#has', function(assert){
    var o, f, M;
    assert.ok(isFunction(Map.prototype.has), 'is function');
    o = {};
    f = freeze({});
    M = new Map([[NaN, 1], [2, 1], [3, 1], [2, 5], [1, 4], [f, 42], [o, o]]);
    assert.ok(M.has(NaN));
    assert.ok(M.has(o));
    assert.ok(M.has(2));
    assert.ok(M.has(f));
    assert.ok(!M.has(4));
    return assert.ok(!M.has({}));
  });
  test('Map#set', function(assert){
    var o, M, chain, f;
    assert.ok(isFunction(Map.prototype.set), 'is function');
    o = {};
    M = new Map().set(NaN, 1).set(2, 1).set(3, 1).set(2, 5).set(1, 4).set(o, o);
    assert.ok(M.size === 5);
    chain = M.set(7, 2);
    assert.strictEqual(chain, M);
    M.set(7, 2);
    assert.strictEqual(M.size, 6);
    assert.strictEqual(M.get(7), 2);
    assert.strictEqual(M.get(NaN), 1);
    M.set(NaN, 42);
    assert.strictEqual(M.size, 6);
    assert.strictEqual(M.get(NaN), 42);
    M.set({}, 11);
    assert.strictEqual(M.size, 7);
    assert.strictEqual(M.get(o), o);
    M.set(o, 27);
    assert.strictEqual(M.size, 7);
    assert.strictEqual(M.get(o), 27);
    assert.strictEqual(new Map().set(NaN, 2).set(NaN, 3).set(NaN, 4).size, 1);
    M = new Map().set(freeze(f = {}), 42);
    return assert.strictEqual(M.get(f), 42);
  });
  test('Map#size', function(assert){
    var size, sizeDesc;
    size = new Map().set(2, 1).size;
    assert.strictEqual(typeof size, 'number', 'size is number');
    assert.strictEqual(size, 1, 'size is correct');
    if (function(){
      try {
        return 2 === core.Object.defineProperty({}, 'a', {
          get: function(){
            return 2;
          }
        }).a;
      } catch (e$) {}
    }()) {
      sizeDesc = getOwnPropertyDescriptor(Map.prototype, 'size');
      assert.ok(sizeDesc && sizeDesc.get, 'size is getter');
      assert.ok(sizeDesc && !sizeDesc.set, 'size isnt setter');
      return assert.throws(function(){
        return Map.prototype.size;
      }, TypeError);
    }
  });
  test('Map & -0', function(assert){
    var map;
    map = new Map;
    map.set(-0, 1);
    assert.strictEqual(map.size, 1);
    assert.ok(map.has(0));
    assert.ok(map.has(-0));
    assert.strictEqual(map.get(0), 1);
    assert.strictEqual(map.get(-0), 1);
    map.forEach(function(val, key){
      return assert.ok(!same(key, -0));
    });
    map['delete'](-0);
    assert.strictEqual(map.size, 0);
    map = new Map([[-0, 1]]);
    return map.forEach(function(val, key){
      return assert.ok(!same(key, -0));
    });
  });
  test('Map#@@toStringTag', function(assert){
    return assert.strictEqual(Map.prototype[Symbol != null ? Symbol.toStringTag : void 8], 'Map', 'Map::@@toStringTag is `Map`');
  });
  test('Map Iterator', function(assert){
    var map, keys, iterator;
    map = new Map([['a', 1], ['b', 2], ['c', 3], ['d', 4]]);
    keys = [];
    iterator = map.keys();
    keys.push(iterator.next().value);
    assert.ok(map['delete']('a'));
    assert.ok(map['delete']('b'));
    assert.ok(map['delete']('c'));
    map.set('e');
    keys.push(iterator.next().value);
    keys.push(iterator.next().value);
    assert.ok(iterator.next().done);
    map.set('f');
    assert.ok(iterator.next().done);
    return assert.deepEqual(keys, ['a', 'd', 'e']);
  });
  test('Map#keys', function(assert){
    var iter;
    assert.ok(typeof Map.prototype.keys === 'function', 'is function');
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]).keys();
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Map Iterator');
    assert.deepEqual(iter.next(), {
      value: 'a',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 's',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'd',
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Map#values', function(assert){
    var iter;
    assert.ok(typeof Map.prototype.values === 'function', 'is function');
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]).values();
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Map Iterator');
    assert.deepEqual(iter.next(), {
      value: 'q',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'w',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'e',
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Map#entries', function(assert){
    var iter;
    assert.ok(typeof Map.prototype.entries === 'function', 'is function');
    iter = new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]).entries();
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Map Iterator');
    assert.deepEqual(iter.next(), {
      value: ['a', 'q'],
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: ['s', 'w'],
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: ['d', 'e'],
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Map#@@iterator', function(assert){
    var iter;
    iter = core.getIterator(new Map([['a', 'q'], ['s', 'w'], ['d', 'e']]));
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Map Iterator');
    assert.deepEqual(iter.next(), {
      value: ['a', 'q'],
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: ['s', 'w'],
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: ['d', 'e'],
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.acosh', function(assert){
    var epsilon, sameValue, acosh;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    acosh = core.Math.acosh;
    assert.ok(toString$.call(acosh).slice(8, -1) === 'Function', 'is function');
    sameValue(acosh(NaN), NaN);
    sameValue(acosh(0.5), NaN);
    sameValue(acosh(-1), NaN);
    sameValue(acosh(-1e300), NaN);
    sameValue(acosh(1), 0);
    assert.strictEqual(acosh(Infinity), Infinity);
    assert.ok(epsilon(acosh(1234), 7.811163220849231));
    assert.ok(epsilon(acosh(8.88), 2.8737631531629235));
    assert.ok(epsilon(acosh(1e+160), 369.10676205960726));
    assert.ok(epsilon(acosh(Number.MAX_VALUE), 710.475860073944));
    return assert.ok(epsilon(acosh(1 + core.Number.EPSILON), 2.1073424255447017e-8));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.asinh', function(assert){
    var epsilon, sameValue, asinh;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    asinh = core.Math.asinh;
    assert.ok(toString$.call(asinh).slice(8, -1) === 'Function', 'is function');
    sameValue(asinh(NaN), NaN);
    sameValue(asinh(0), 0);
    sameValue(asinh(-0), -0);
    assert.strictEqual(asinh(Infinity), Infinity);
    assert.strictEqual(asinh(-Infinity), -Infinity);
    assert.ok(epsilon(asinh(1234), 7.811163549201245));
    assert.ok(epsilon(asinh(9.99), 2.997227420191335));
    assert.ok(epsilon(asinh(1e150), 346.0809111296668));
    assert.ok(epsilon(asinh(1e7), 16.811242831518268));
    return assert.ok(epsilon(asinh(-1e7), -16.811242831518268));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.atanh', function(assert){
    var epsilon, sameValue, atanh;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    atanh = core.Math.atanh;
    assert.ok(toString$.call(atanh).slice(8, -1) === 'Function', 'is function');
    sameValue(atanh(NaN), NaN);
    sameValue(atanh(-2), NaN);
    sameValue(atanh(-1.5), NaN);
    sameValue(atanh(2), NaN);
    sameValue(atanh(1.5), NaN);
    assert.strictEqual(atanh(-1), -Infinity);
    assert.strictEqual(atanh(1), Infinity);
    sameValue(atanh(0), 0);
    sameValue(atanh(-0), -0);
    sameValue(atanh(-1e300), NaN);
    sameValue(atanh(1e300), NaN);
    assert.ok(epsilon(atanh(0.5), 0.5493061443340549));
    assert.ok(epsilon(atanh(-0.5), -0.5493061443340549));
    return assert.ok(epsilon(atanh(0.444), 0.47720201260109457));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.cbrt', function(assert){
    var epsilon, sameValue, cbrt;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    cbrt = core.Math.cbrt;
    assert.ok(toString$.call(cbrt).slice(8, -1) === 'Function', 'is function');
    sameValue(cbrt(NaN), NaN);
    sameValue(cbrt(0), 0);
    sameValue(cbrt(-0), -0);
    assert.strictEqual(cbrt(Infinity), Infinity);
    assert.strictEqual(cbrt(-Infinity), -Infinity);
    assert.strictEqual(cbrt(-8), -2);
    assert.strictEqual(cbrt(8), 2);
    assert.ok(epsilon(cbrt(-1000), -10));
    return assert.ok(epsilon(cbrt(1000), 10));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.clz32', function(assert){
    var sameValue, clz32;
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    clz32 = core.Math.clz32;
    assert.ok(toString$.call(clz32).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(clz32(0), 32);
    assert.strictEqual(clz32(1), 31);
    sameValue(clz32(-1), 0);
    assert.strictEqual(clz32(0.6), 32);
    sameValue(clz32(Math.pow(2, 32) - 1), 0);
    return assert.strictEqual(clz32(Math.pow(2, 32)), 32);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.cosh', function(assert){
    var epsilon, sameValue, cosh;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    cosh = core.Math.cosh;
    assert.ok(toString$.call(cosh).slice(8, -1) === 'Function', 'is function');
    sameValue(cosh(NaN), NaN);
    assert.strictEqual(cosh(0), 1);
    assert.strictEqual(cosh(-0), 1);
    assert.strictEqual(cosh(Infinity), Infinity);
    assert.strictEqual(cosh(-Infinity), Infinity);
    assert.ok(epsilon(cosh(12), 81377.39571257407, 3e-11));
    assert.ok(epsilon(cosh(22), 1792456423.065795780980053377, 1e-5));
    assert.ok(epsilon(cosh(-10), 11013.23292010332313972137));
    return assert.ok(epsilon(cosh(-23), 4872401723.1244513000, 1e-5));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.expm1', function(assert){
    var epsilon, sameValue, expm1;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    expm1 = core.Math.expm1;
    assert.ok(toString$.call(expm1).slice(8, -1) === 'Function', 'is function');
    sameValue(expm1(NaN), NaN);
    sameValue(expm1(0), 0);
    sameValue(expm1(-0), -0);
    assert.strictEqual(expm1(Infinity), Infinity);
    assert.strictEqual(expm1(-Infinity), -1);
    return assert.ok(epsilon(expm1(10), 22025.465794806718, assert.ok(epsilon(expm1(-10), -0.9999546000702375))));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.fround', function(assert){
    var sameValue, fround, maxFloat32, minFloat32;
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    fround = core.Math.fround;
    assert.ok(toString$.call(fround).slice(8, -1) === 'Function', 'is function');
    sameValue(fround(void 8), NaN);
    sameValue(fround(NaN), NaN);
    sameValue(fround(0), 0);
    sameValue(fround(-0), -0);
    sameValue(fround(Number.MIN_VALUE), 0);
    sameValue(fround(-Number.MIN_VALUE), -0);
    assert.strictEqual(fround(Infinity), Infinity);
    assert.strictEqual(fround(-Infinity), -Infinity);
    assert.strictEqual(fround(1.7976931348623157e+308), Infinity);
    assert.strictEqual(fround(-1.7976931348623157e+308), -Infinity);
    assert.strictEqual(fround(3.4028235677973366e+38), Infinity);
    assert.strictEqual(fround(3), 3);
    assert.strictEqual(fround(-3), -3);
    maxFloat32 = 3.4028234663852886e+38;
    minFloat32 = 1.401298464324817e-45;
    assert.strictEqual(fround(maxFloat32), maxFloat32);
    assert.strictEqual(fround(-maxFloat32), -maxFloat32);
    assert.strictEqual(fround(maxFloat32 + Math.pow(2, Math.pow(2, 8 - 1) - 1 - 23 - 2)), maxFloat32);
    assert.strictEqual(fround(minFloat32), minFloat32);
    assert.strictEqual(fround(-minFloat32), -minFloat32);
    sameValue(fround(minFloat32 / 2), 0);
    sameValue(fround(-minFloat32 / 2), -0);
    assert.strictEqual(fround(minFloat32 / 2 + Math.pow(2, -202)), minFloat32);
    return assert.strictEqual(fround(-minFloat32 / 2 - Math.pow(2, -202)), -minFloat32);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.hypot', function(assert){
    var epsilon, sameValue, hypot, sqrt;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    hypot = core.Math.hypot;
    sqrt = Math.sqrt;
    assert.ok(toString$.call(hypot).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(hypot(), 0);
    assert.strictEqual(hypot(1), 1);
    sameValue(hypot('', 0), 0);
    sameValue(hypot(0, ''), 0);
    assert.strictEqual(hypot(Infinity, 0), Infinity);
    assert.strictEqual(hypot(-Infinity, 0), Infinity);
    assert.strictEqual(hypot(0, Infinity), Infinity);
    assert.strictEqual(hypot(0, -Infinity), Infinity);
    assert.strictEqual(hypot(Infinity, NaN), Infinity);
    assert.strictEqual(hypot(NaN, -Infinity), Infinity);
    sameValue(hypot(NaN, 0), NaN);
    sameValue(hypot(0, NaN), NaN);
    sameValue(hypot(0, -0), 0);
    sameValue(hypot(0, 0), 0);
    sameValue(hypot(-0, -0), 0);
    sameValue(hypot(-0, 0), 0);
    assert.strictEqual(hypot(0, 1), 1);
    assert.strictEqual(hypot(0, -1), 1);
    assert.strictEqual(hypot(-0, 1), 1);
    assert.strictEqual(hypot(-0, -1), 1);
    sameValue(hypot(0), 0);
    assert.strictEqual(hypot(1), 1);
    assert.strictEqual(hypot(2), 2);
    assert.strictEqual(hypot(0, 0, 1), 1);
    assert.strictEqual(hypot(0, 1, 0), 1);
    assert.strictEqual(hypot(1, 0, 0), 1);
    assert.strictEqual(hypot(2, 3, 4), sqrt(2 * 2 + 3 * 3 + 4 * 4));
    assert.strictEqual(hypot(2, 3, 4, 5), sqrt(2 * 2 + 3 * 3 + 4 * 4 + 5 * 5));
    assert.ok(epsilon(hypot(66, 66), 93.33809511662427));
    assert.ok(epsilon(hypot(0.1, 100), 100.0000499999875));
    assert.strictEqual(hypot(1e+300, 1e+300), 1.4142135623730952e+300);
    assert.strictEqual(Math.floor(hypot(1e-300, 1e-300) * 1e308), 141421356);
    assert.strictEqual(hypot(1e+300, 1e+300, 2, 3), 1.4142135623730952e+300);
    assert.strictEqual(hypot(-3, 4), 5);
    return assert.strictEqual(hypot(3, -4), 5);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.imul', function(assert){
    var sameValue, imul;
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    imul = core.Math.imul;
    assert.ok(toString$.call(imul).slice(8, -1) === 'Function', 'is function');
    sameValue(imul(0, 0), 0);
    assert.strictEqual(imul(123, 456), 56088);
    assert.strictEqual(imul(-123, 456), -56088);
    assert.strictEqual(imul(123, -456), -56088);
    assert.strictEqual(imul(19088743, 4275878552), 602016552);
    sameValue(imul(false, 7), 0);
    sameValue(imul(7, false), 0);
    sameValue(imul(false, false), 0);
    assert.strictEqual(imul(true, 7), 7);
    assert.strictEqual(imul(7, true), 7);
    assert.strictEqual(imul(true, true), 1);
    sameValue(imul(void 8, 7), 0);
    sameValue(imul(7, void 8), 0);
    sameValue(imul(void 8, void 8), 0);
    sameValue(imul('str', 7), 0);
    sameValue(imul(7, 'str'), 0);
    sameValue(imul({}, 7), 0);
    sameValue(imul(7, {}), 0);
    sameValue(imul([], 7), 0);
    sameValue(imul(7, []), 0);
    assert.strictEqual(imul(0xffffffff, 5), -5);
    assert.strictEqual(imul(0xfffffffe, 5), -10);
    assert.strictEqual(imul(2, 4), 8);
    assert.strictEqual(imul(-1, 8), -8);
    assert.strictEqual(imul(-2, -2), 4);
    sameValue(imul(-0, 7), 0);
    sameValue(imul(7, -0), 0);
    sameValue(imul(0.1, 7), 0);
    sameValue(imul(7, 0.1), 0);
    sameValue(imul(0.9, 7), 0);
    sameValue(imul(7, 0.9), 0);
    assert.strictEqual(imul(1.1, 7), 7);
    assert.strictEqual(imul(7, 1.1), 7);
    assert.strictEqual(imul(1.9, 7), 7);
    return assert.strictEqual(imul(7, 1.9), 7);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.log10', function(assert){
    var epsilon, sameValue, log10;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    log10 = core.Math.log10;
    assert.ok(toString$.call(log10).slice(8, -1) === 'Function', 'is function');
    sameValue(log10(''), log10(0));
    sameValue(log10(NaN), NaN);
    sameValue(log10(-1), NaN);
    sameValue(log10(0), -Infinity);
    sameValue(log10(-0), -Infinity);
    sameValue(log10(1), 0);
    sameValue(log10(Infinity), Infinity);
    assert.ok(epsilon(log10(0.1), -1));
    assert.ok(epsilon(log10(0.5), -0.3010299956639812));
    assert.ok(epsilon(log10(1.5), 0.17609125905568124));
    assert.ok(epsilon(log10(5), 0.6989700043360189));
    return assert.ok(epsilon(log10(50), 1.6989700043360187));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.log1p', function(assert){
    var epsilon, sameValue, log1p;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    log1p = core.Math.log1p;
    assert.ok(toString$.call(log1p).slice(8, -1) === 'Function', 'is function');
    sameValue(log1p(''), log1p(0));
    sameValue(log1p(NaN), NaN);
    sameValue(log1p(-2), NaN);
    sameValue(log1p(-1), -Infinity);
    sameValue(log1p(0), 0);
    sameValue(log1p(-0), -0);
    sameValue(log1p(Infinity), Infinity);
    assert.ok(epsilon(log1p(5), 1.791759469228055));
    return assert.ok(epsilon(log1p(50), 3.9318256327243257));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.log2', function(assert){
    var epsilon, sameValue, log2;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    log2 = core.Math.log2;
    assert.ok(toString$.call(log2).slice(8, -1) === 'Function', 'is function');
    sameValue(log2(''), log2(0));
    sameValue(log2(NaN), NaN);
    sameValue(log2(-1), NaN);
    sameValue(log2(0), -Infinity);
    sameValue(log2(-0), -Infinity);
    sameValue(log2(1), 0);
    sameValue(log2(Infinity), Infinity);
    sameValue(log2(0.5), -1);
    sameValue(log2(32), 5);
    return assert.ok(epsilon(log2(5), 2.321928094887362));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.sign', function(assert){
    var sameValue, sign;
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    sign = core.Math.sign;
    assert.ok(toString$.call(sign).slice(8, -1) === 'Function', 'is function');
    sameValue(sign(NaN), NaN);
    sameValue(sign(), NaN);
    sameValue(sign(-0), -0);
    sameValue(sign(0), 0);
    assert.strictEqual(sign(Infinity), 1);
    assert.strictEqual(sign(-Infinity), -1);
    assert.strictEqual(sign(13510798882111488), 1);
    assert.strictEqual(sign(-13510798882111488), -1);
    assert.strictEqual(sign(42.5), 1);
    return assert.strictEqual(sign(-42.5), -1);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.sinh', function(assert){
    var epsilon, sameValue, sinh;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    sinh = core.Math.sinh;
    assert.ok(toString$.call(sinh).slice(8, -1) === 'Function', 'is function');
    sameValue(sinh(NaN), NaN);
    sameValue(sinh(0), 0);
    sameValue(sinh(-0), -0);
    assert.strictEqual(sinh(Infinity), Infinity);
    assert.strictEqual(sinh(-Infinity), -Infinity);
    assert.ok(epsilon(sinh(-5), -74.20321057778875));
    assert.ok(epsilon(sinh(2), 3.6268604078470186));
    return assert.strictEqual(sinh(-2e-17), -2e-17);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.tanh', function(assert){
    var epsilon, sameValue, tanh;
    epsilon = function(a, b, E){
      return Math.abs(a - b) <= (E != null ? E : 1e-11);
    };
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    tanh = core.Math.tanh;
    assert.ok(toString$.call(tanh).slice(8, -1) === 'Function', 'is function');
    sameValue(tanh(NaN), NaN);
    sameValue(tanh(0), 0);
    sameValue(tanh(-0), -0);
    assert.strictEqual(tanh(Infinity), 1);
    assert.strictEqual(tanh(90), 1);
    return assert.ok(epsilon(tanh(10), 0.9999999958776927));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Math.trunc', function(assert){
    var sameValue, trunc;
    sameValue = function(a, b, c){
      return assert.ok(a === b
        ? a !== 0 || 1 / a === 1 / b
        : a != a && b != b, c);
    };
    trunc = core.Math.trunc;
    assert.ok(toString$.call(trunc).slice(8, -1) === 'Function', 'is function');
    sameValue(trunc(NaN), NaN, 'NaN -> NaN');
    sameValue(trunc(-0), -0, '-0 -> -0');
    sameValue(trunc(0), 0, '0 -> 0');
    sameValue(trunc(Infinity), Infinity, 'Infinity -> Infinity');
    sameValue(trunc(-Infinity), -Infinity, '-Infinity -> -Infinity');
    sameValue(trunc(null), 0, 'null -> 0');
    sameValue(trunc({}), NaN, '{} -> NaN');
    assert.strictEqual(trunc([]), 0, '[] -> 0');
    assert.strictEqual(trunc(1.01), 1, '1.01 -> 0');
    assert.strictEqual(trunc(1.99), 1, '1.99 -> 0');
    assert.strictEqual(trunc(-1), -1, '-1 -> -1');
    assert.strictEqual(trunc(-1.99), -1, '-1.99 -> -1');
    assert.strictEqual(trunc(-555.555), -555, '-555.555 -> -555');
    assert.strictEqual(trunc(0x20000000000001), 0x20000000000001, '0x20000000000001 -> 0x20000000000001');
    return assert.strictEqual(trunc(-0x20000000000001), -0x20000000000001, '-0x20000000000001 -> -0x20000000000001');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Number.EPSILON', function(assert){
    var EPSILON;
    EPSILON = core.Number.EPSILON;
    assert.ok('EPSILON' in core.Number, 'EPSILON in Number');
    assert.strictEqual(EPSILON, Math.pow(2, -52), 'Is 2^-52');
    assert.ok(1 !== 1 + EPSILON, '1 isnt 1 + EPSILON');
    return assert.strictEqual(1, 1 + EPSILON / 2, '1 is 1 + EPSILON / 2');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Number.isFinite', function(assert){
    var isFinite, create, i$, x$, ref$, len$, y$, e, results$ = [];
    isFinite = core.Number.isFinite;
    create = core.Object.create;
    assert.ok(toString$.call(isFinite).slice(8, -1) === 'Function', 'is function');
    for (i$ = 0, len$ = (ref$ = [1, 0.1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      assert.ok(isFinite(x$), "isFinite " + typeof x$ + " " + x$);
    }
    for (i$ = 0, len$ = (ref$ = [NaN, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      y$ = ref$[i$];
      results$.push(assert.ok(!isFinite(y$), "not isFinite " + typeof y$ + " " + (fn1$())));
    }
    return results$;
    function fn$(){}
    function fn1$(){
      try {
        return String(y$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Number.isInteger', function(assert){
    var isInteger, create, i$, x$, ref$, len$, y$, e, results$ = [];
    isInteger = core.Number.isInteger;
    create = core.Object.create;
    assert.ok(toString$.call(isInteger).slice(8, -1) === 'Function', 'is function');
    for (i$ = 0, len$ = (ref$ = [1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      assert.ok(isInteger(x$), "isInteger " + typeof x$ + " " + x$);
    }
    for (i$ = 0, len$ = (ref$ = [NaN, 0.1, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      y$ = ref$[i$];
      results$.push(assert.ok(!isInteger(y$), "not isInteger " + typeof y$ + " " + (fn1$())));
    }
    return results$;
    function fn$(){}
    function fn1$(){
      try {
        return String(y$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Number.isNaN', function(assert){
    var isNaN, create, i$, x$, ref$, len$, e, results$ = [];
    isNaN = core.Number.isNaN;
    create = core.Object.create;
    assert.ok(toString$.call(isNaN).slice(8, -1) === 'Function', 'is function');
    assert.ok(isNaN(NaN), 'Number.isNaN NaN');
    for (i$ = 0, len$ = (ref$ = [1, 0.1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      results$.push(assert.ok(!isNaN(x$), "not Number.isNaN " + typeof x$ + " " + (fn1$())));
    }
    return results$;
    function fn$(){}
    function fn1$(){
      try {
        return String(x$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Number.isSafeInteger', function(assert){
    var isSafeInteger, create, i$, x$, ref$, len$, y$, e, results$ = [];
    isSafeInteger = core.Number.isSafeInteger;
    create = core.Object.create;
    assert.ok(toString$.call(isSafeInteger).slice(8, -1) === 'Function', 'is function');
    for (i$ = 0, len$ = (ref$ = [1, -1, Math.pow(2, 16), Math.pow(2, 16) - 1, Math.pow(2, 31), Math.pow(2, 31) - 1, Math.pow(2, 32), Math.pow(2, 32) - 1, -0, 9007199254740991, -9007199254740991]).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      assert.ok(isSafeInteger(x$), "isSafeInteger " + typeof x$ + " " + x$);
    }
    for (i$ = 0, len$ = (ref$ = [9007199254740992, -9007199254740992, NaN, 0.1, Infinity, 'NaN', '5', false, new Number(NaN), new Number(Infinity), new Number(5), new Number(0.1), void 8, null, {}, fn$, create(null)]).length; i$ < len$; ++i$) {
      y$ = ref$[i$];
      results$.push(assert.ok(!isSafeInteger(y$), "not isSafeInteger " + typeof y$ + " " + (fn1$())));
    }
    return results$;
    function fn$(){}
    function fn1$(){
      try {
        return String(y$);
      } catch (e$) {
        e = e$;
        return 'Object.create(null)';
      }
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Number.MAX_SAFE_INTEGER', function(assert){
    return assert.strictEqual(core.Number.MAX_SAFE_INTEGER, Math.pow(2, 53) - 1, 'Is 2^53 - 1');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Number.MIN_SAFE_INTEGER', function(assert){
    return assert.strictEqual(core.Number.MIN_SAFE_INTEGER, -Math.pow(2, 53) + 1, 'Is -2^53 + 1');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Number.parseFloat', function(assert){
    return assert.ok(toString$.call(core.Number.parseFloat).slice(8, -1) === 'Function', 'is function');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Number.parseInt', function(assert){
    return assert.ok(toString$.call(core.Number.parseInt).slice(8, -1) === 'Function', 'is function');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, descriptors, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  descriptors = function(){
    try {
      return 2 === core.Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  test('Object.assign', function(assert){
    var ref$, assign, keys, defineProperty, foo, str, c, d, D, O, string, i$, x$, len$;
    ref$ = core.Object, assign = ref$.assign, keys = ref$.keys, defineProperty = ref$.defineProperty;
    assert.ok(toString$.call(assign).slice(8, -1) === 'Function', 'is function');
    foo = {
      q: 1
    };
    assert.strictEqual(foo, assign(foo, {
      bar: 2
    }), 'assign return target');
    assert.strictEqual(foo.bar, 2, 'assign define properties');
    assert.deepEqual(assign({}, {
      q: 1
    }, {
      w: 2
    }), {
      q: 1,
      w: 2
    });
    assert.deepEqual(assign({}, 'qwe'), {
      0: 'q',
      1: 'w',
      2: 'e'
    });
    assert.throws(function(){
      return assign(null, {
        q: 1
      });
    }, TypeError);
    assert.throws(function(){
      return assign(void 8, {
        q: 1
      });
    }, TypeError);
    str = assign('qwe', {
      q: 1
    });
    assert.strictEqual(typeof str, 'object');
    assert.strictEqual(String(str), 'qwe');
    assert.strictEqual(str.q, 1);
    if (descriptors) {
      foo = {
        baz: 1
      };
      assign(foo, defineProperty({}, 'bar', {
        get: function(){
          return this.baz + 1;
        }
      }));
      assert.ok(foo.bar === void 8, "assign don't copy descriptors");
      c = core.Symbol('c');
      d = core.Symbol('d');
      D = (ref$ = {
        a: 'a'
      }, ref$[c] = 'c', ref$);
      defineProperty(D, 'b', {
        value: 'b'
      });
      defineProperty(D, d, {
        value: 'd'
      });
      O = assign({}, D);
      assert.strictEqual(O.a, 'a', 'a');
      assert.strictEqual(O.b, void 8, 'b');
      assert.strictEqual(O[c], 'c', 'c');
      assert.strictEqual(O[d], void 8, 'd');
      try {
        assert.strictEqual(Function('return core.Object.assign({b: 1}, {get a(){delete this.b;},b: 2})')().b, 1);
      } catch (e$) {}
    }
    string = 'abcdefghijklmnopqrst';
    O = {};
    for (i$ = 0, len$ = (ref$ = string.split('')).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      O[x$] = x$;
    }
    return assert.strictEqual(keys(assign({}, O)).join(''), string);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Object.is', function(assert){
    var same;
    same = core.Object.is;
    assert.ok(toString$.call(same).slice(8, -1) === 'Function', 'is function');
    assert.ok(same(1, 1), '1 is 1');
    assert.ok(same(NaN, NaN), '1 is 1');
    assert.ok(!same(0, -0), '0 isnt -0');
    return assert.ok(!same({}, {}), '{} isnt {}');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  if (Object.setPrototypeOf || '__proto__' in Object.prototype) {
    module = QUnit.module, test = QUnit.test;
    module('ES6');
    test('Object.setPrototypeOf', function(assert){
      var setPrototypeOf, tmp;
      setPrototypeOf = core.Object.setPrototypeOf;
      assert.ok(toString$.call(setPrototypeOf).slice(8, -1) === 'Function', 'is function');
      assert.ok('apply' in setPrototypeOf({}, Function.prototype), 'Parent properties in target');
      assert.strictEqual(setPrototypeOf({
        a: 2
      }, {
        b: function(){
          return Math.pow(this.a, 2);
        }
      }).b(), 4, 'Child and parent properties in target');
      assert.strictEqual(setPrototypeOf(tmp = {}, {
        a: 1
      }), tmp, 'setPrototypeOf return target');
      return assert.ok(!('toString' in setPrototypeOf({}, null)), 'Can set null as prototype');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Object static methods accept primitives', function(assert){
    var i$, ref$, len$, method, j$, ref1$, len1$, value;
    for (i$ = 0, len$ = (ref$ = ['freeze', 'seal', 'preventExtensions', 'getOwnPropertyDescriptor', 'getPrototypeOf', 'isExtensible', 'isSealed', 'isFrozen', 'keys', 'getOwnPropertyNames']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [42, 'foo', false]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        assert.ok((fn$()), "Object." + method + " accept " + toString$.call(value).slice(8, -1));
      }
    }
    for (i$ = 0, len$ = (ref$ = ['freeze', 'seal', 'preventExtensions']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [42, 'foo', false, null, void 8, {}]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        assert.strictEqual(core.Object[method](value), value, "Object." + method + " returns target on " + toString$.call(value).slice(8, -1));
      }
    }
    for (i$ = 0, len$ = (ref$ = ['isSealed', 'isFrozen']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [42, 'foo', false, null, void 8]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        assert.strictEqual(core.Object[method](value), true, "Object." + method + " returns true on " + toString$.call(value).slice(8, -1));
      }
    }
    for (i$ = 0, len$ = (ref$ = [42, 'foo', false, null, void 8]).length; i$ < len$; ++i$) {
      value = ref$[i$];
      assert.strictEqual(core.Object.isExtensible(value), false, "Object.isExtensible returns false on " + toString$.call(value).slice(8, -1));
    }
    for (i$ = 0, len$ = (ref$ = ['getOwnPropertyDescriptor', 'getPrototypeOf', 'keys', 'getOwnPropertyNames']).length; i$ < len$; ++i$) {
      method = ref$[i$];
      for (j$ = 0, len1$ = (ref1$ = [null, void 8]).length; j$ < len1$; ++j$) {
        value = ref1$[j$];
        assert.throws(fn1$, TypeError, "Object." + method + " assert.throws on " + value);
      }
    }
    return assert.strictEqual(core.Object.getPrototypeOf('foo'), String.prototype);
    function fn$(){
      try {
        core.Object[method](value);
        return true;
      } catch (e$) {}
    }
    function fn1$(){
      return core.Object[method](value);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, iterator, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  iterator = core.Symbol.iterator;
  test('Promise', function(assert){
    return assert.ok(isFunction(core.Promise), 'is function');
  });
  test('Promise#then', function(assert){
    return assert.ok(isFunction(core.Promise.prototype.then), 'is function');
  });
  test('Promise#catch', function(assert){
    return assert.ok(isFunction(core.Promise.prototype['catch']), 'is function');
  });
  test('Promise#@@toStringTag', function(assert){
    return assert.ok(core.Promise.prototype[core.Symbol.toStringTag] === 'Promise', 'Promise::@@toStringTag is `Promise`');
  });
  test('Promise.all', function(assert){
    var passed, iter, next, a, done;
    assert.ok(isFunction(core.Promise.all), 'is function');
    passed = false;
    iter = core.Array.values([1, 2, 3]);
    next = bind$(iter, 'next');
    iter.next = function(){
      passed = true;
      return next();
    };
    core.Promise.all(iter)['catch'](function(){});
    assert.ok(passed, 'works with iterables');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    core.Promise.all(a);
    return assert.ok(done);
  });
  test('Promise.race', function(assert){
    var passed, iter, next, a, done;
    assert.ok(isFunction(core.Promise.race), 'is function');
    passed = false;
    iter = core.Array.values([1, 2, 3]);
    next = bind$(iter, 'next');
    iter.next = function(){
      passed = true;
      return next();
    };
    core.Promise.race(iter)['catch'](function(){});
    assert.ok(passed, 'works with iterables');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    core.Promise.race(a);
    return assert.ok(done);
  });
  test('Promise.resolve', function(assert){
    return assert.ok(isFunction(core.Promise.resolve), 'is function');
  });
  test('Promise.reject', function(assert){
    return assert.ok(isFunction(core.Promise.reject), 'is function');
  });
  if (core.Object.setPrototypeOf) {
    test('Promise subclassing', function(assert){
      var SubPromise, p1, p2, p3;
      SubPromise = function(it){
        var self;
        self = new core.Promise(it);
        core.Object.setPrototypeOf(self, SubPromise.prototype);
        self.mine = 'subclass';
        return self;
      };
      core.Object.setPrototypeOf(SubPromise, core.Promise);
      SubPromise.prototype = core.Object.create(core.Promise.prototype);
      SubPromise.prototype.constructor = SubPromise;
      p1 = SubPromise.resolve(5);
      assert.strictEqual(p1.mine, 'subclass');
      p1 = p1.then(function(it){
        return assert.strictEqual(it, 5);
      });
      assert.strictEqual(p1.mine, 'subclass');
      p2 = new SubPromise(function(it){
        return it(6);
      });
      assert.strictEqual(p2.mine, 'subclass');
      p2 = p2.then(function(it){
        return assert.strictEqual(it, 6);
      });
      assert.strictEqual(p2.mine, 'subclass');
      p3 = SubPromise.all([p1, p2]);
      assert.strictEqual(p3.mine, 'subclass');
      assert.ok(p3 instanceof core.Promise);
      assert.ok(p3 instanceof SubPromise);
      return p3.then(assert.async(), function(it){
        return assert.ok(it, false);
      });
    });
  }
  function bind$(obj, key, target){
    return function(){ return (target || obj)[key].apply(obj, arguments) };
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Reflect.apply', function(assert){
    var apply, C;
    apply = core.Reflect.apply;
    assert.ok(toString$.call(apply).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(apply.length, 3, 'arity is 3');
    if ('name' in apply) {
      assert.strictEqual(apply.name, 'apply', 'name is "apply"');
    }
    assert.strictEqual(apply(Array.prototype.push, [1, 2], [3, 4, 5]), 5);
    C = function(a, b, c){
      return a + b + c;
    };
    C.apply = 42;
    assert.strictEqual(apply(C, null, ['foo', 'bar', 'baz']), 'foobarbaz', 'works with redefined apply');
    return assert.throws(function(){
      return apply(42, null, []);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, getPrototypeOf, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  getPrototypeOf = core.Object.getPrototypeOf;
  test('Reflect.construct', function(assert){
    var construct, C, inst, f, e;
    construct = core.Reflect.construct;
    assert.ok(toString$.call(construct).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(construct.length, 2, 'arity is 2');
    if ('name' in construct) {
      assert.strictEqual(construct.name, 'construct', 'name is "construct"');
    }
    C = function(a, b, c){
      return this.qux = a + b + c;
    };
    assert.strictEqual(construct(C, ['foo', 'bar', 'baz']).qux, 'foobarbaz', 'basic');
    C.apply = 42;
    assert.strictEqual(construct(C, ['foo', 'bar', 'baz']).qux, 'foobarbaz', 'works with redefined apply');
    inst = construct(function(){
      return this.x = 42;
    }, [], Array);
    assert.strictEqual(inst.x, 42, 'constructor with newTarget');
    assert.ok(inst instanceof Array, 'prototype with newTarget');
    assert.throws(function(){
      return construct(42, []);
    }, TypeError, 'throws on primitive');
    f = function(){};
    f.prototype = 42;
    assert.ok((function(){
      try {
        return getPrototypeOf(construct(f, [])) === Object.prototype;
      } catch (e$) {
        e = e$;
        return false;
      }
    }()));
    return assert.strictEqual(construct(core.Set, [[1, 2, 3, 2, 1]]).size, 3, 'works with native constructors');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, ref$, defineProperty, getOwnPropertyDescriptor, MODERN, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  test('Reflect.defineProperty', function(assert){
    var defineProperty, O;
    defineProperty = core.Reflect.defineProperty;
    assert.ok(toString$.call(defineProperty).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(defineProperty.length, 3, 'arity is 3');
    if ('name' in defineProperty) {
      assert.strictEqual(defineProperty.name, 'defineProperty', 'name is "defineProperty"');
    }
    O = {};
    assert.strictEqual(defineProperty(O, 'foo', {
      value: 123
    }), true);
    assert.strictEqual(O.foo, 123);
    if (MODERN) {
      O = {};
      defineProperty(O, 'foo', {
        value: 123,
        enumerable: true
      });
      assert.deepEqual(getOwnPropertyDescriptor(O, 'foo'), {
        value: 123,
        enumerable: true,
        configurable: false,
        writable: false
      });
      assert.strictEqual(defineProperty(O, 'foo', {
        value: 42
      }), false);
    }
    return assert.throws(function(){
      return defineProperty(42, 'foo', {
        value: 42
      });
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, defineProperty, MODERN, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  defineProperty = core.Object.defineProperty;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  test('Reflect.deleteProperty', function(assert){
    var deleteProperty, O;
    deleteProperty = core.Reflect.deleteProperty;
    assert.ok(toString$.call(deleteProperty).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(deleteProperty.length, 2, 'arity is 2');
    if ('name' in deleteProperty) {
      assert.strictEqual(deleteProperty.name, 'deleteProperty', 'name is "deleteProperty"');
    }
    O = {
      bar: 456
    };
    assert.strictEqual(deleteProperty(O, 'bar'), true);
    assert.ok(!in$('bar', O));
    if (MODERN) {
      assert.strictEqual(deleteProperty(defineProperty({}, 'foo', {
        value: 42
      }), 'foo'), false);
    }
    return assert.throws(function(){
      return deleteProperty(42, 'foo');
    }, TypeError, 'throws on primitive');
  });
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, defineProperty, from, MODERN, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  defineProperty = core.Object.defineProperty;
  from = core.Array.from;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  test('Reflect.enumerate', function(assert){
    var enumerate, iterator, obj, i, ref$;
    enumerate = core.Reflect.enumerate;
    iterator = core.Symbol.iterator;
    assert.ok(toString$.call(enumerate).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(enumerate.length, 1, 'arity is 1');
    if ('name' in enumerate) {
      assert.strictEqual(enumerate.name, 'enumerate', 'name is "enumerate"');
    }
    obj = {
      foo: 1,
      bar: 2
    };
    i = enumerate(obj);
    assert.ok(iterator in i, 'returns iterator');
    assert.deepEqual(from(i), ['foo', 'bar'], 'bisic');
    obj = {
      q: 1,
      w: 2,
      e: 3
    };
    i = enumerate(obj);
    delete obj.w;
    assert.deepEqual(from(i), ['q', 'e'], 'ignore holes');
    obj = (ref$ = clone$({
      q: 1,
      w: 2,
      e: 3
    }), ref$.a = 4, ref$.s = 5, ref$.d = 6, ref$);
    assert.deepEqual(from(enumerate(obj)).sort(), ['a', 'd', 'e', 'q', 's', 'w'], 'works with prototype');
    return assert.throws(function(){
      return enumerate(42);
    }, TypeError, 'throws on primitive');
  });
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Reflect.getOwnPropertyDescriptor', function(assert){
    var getOwnPropertyDescriptor, obj, desc;
    getOwnPropertyDescriptor = core.Reflect.getOwnPropertyDescriptor;
    assert.ok(toString$.call(getOwnPropertyDescriptor).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(getOwnPropertyDescriptor.length, 2, 'arity is 2');
    if ('name' in getOwnPropertyDescriptor) {
      assert.strictEqual(getOwnPropertyDescriptor.name, 'getOwnPropertyDescriptor', 'name is "getOwnPropertyDescriptor"');
    }
    obj = {
      baz: 789
    };
    desc = getOwnPropertyDescriptor(obj, 'baz');
    assert.strictEqual(desc.value, 789);
    return assert.throws(function(){
      return getOwnPropertyDescriptor(42, 'constructor');
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Reflect.getPrototypeOf', function(assert){
    var getPrototypeOf;
    getPrototypeOf = core.Reflect.getPrototypeOf;
    assert.ok(toString$.call(getPrototypeOf).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(getPrototypeOf.length, 1, 'arity is 1');
    if ('name' in getPrototypeOf) {
      assert.strictEqual(getPrototypeOf.name, 'getPrototypeOf', 'name is "getPrototypeOf"');
    }
    assert.strictEqual(getPrototypeOf([]), Array.prototype);
    return assert.throws(function(){
      return getPrototypeOf(42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, ref$, defineProperty, create, MODERN, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, create = ref$.create;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  test('Reflect.get', function(assert){
    var get, target, receiver;
    get = core.Reflect.get;
    assert.ok(toString$.call(get).slice(8, -1) === 'Function', 'is function');
    if ('name' in get) {
      assert.strictEqual(get.name, 'get', 'name is "get"');
    }
    assert.strictEqual(get({
      qux: 987
    }, 'qux'), 987);
    if (MODERN) {
      target = create(defineProperty({
        z: 3
      }, 'w', {
        get: function(){
          return this;
        }
      }), {
        x: {
          value: 1
        },
        y: {
          get: function(){
            return this;
          }
        }
      });
      receiver = {};
      assert.strictEqual(get(target, 'x', receiver), 1, 'get x');
      assert.strictEqual(get(target, 'y', receiver), receiver, 'get y');
      assert.strictEqual(get(target, 'z', receiver), 3, 'get z');
      assert.strictEqual(get(target, 'w', receiver), receiver, 'get w');
      assert.strictEqual(get(target, 'u', receiver), void 8, 'get u');
    }
    return assert.throws(function(){
      return get(42, 'constructor');
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('Reflect.has', function(assert){
    var has, O;
    has = core.Reflect.has;
    assert.ok(toString$.call(has).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(has.length, 2, 'arity is 2');
    if ('name' in has) {
      assert.strictEqual(has.name, 'has', 'name is "has"');
    }
    O = {
      qux: 987
    };
    assert.strictEqual(has(O, 'qux'), true);
    assert.strictEqual(has(O, 'qwe'), false);
    assert.strictEqual(has(O, 'toString'), true);
    return assert.throws(function(){
      return has(42, 'constructor');
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, ref$, defineProperty, preventExtensions, MODERN, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, preventExtensions = ref$.preventExtensions;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  test('Reflect.isExtensible', function(assert){
    var isExtensible;
    isExtensible = core.Reflect.isExtensible;
    assert.ok(toString$.call(isExtensible).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(isExtensible.length, 1, 'arity is 1');
    if ('name' in isExtensible) {
      assert.strictEqual(isExtensible.name, 'isExtensible', 'name is "isExtensible"');
    }
    assert.ok(isExtensible({}));
    if (MODERN) {
      assert.ok(!isExtensible(preventExtensions({})));
    }
    return assert.throws(function(){
      return isExtensible(42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, defineProperty, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  defineProperty = core.Object.defineProperty;
  test('Reflect.ownKeys', function(assert){
    var ownKeys, sym, O1, keys, O2;
    ownKeys = core.Reflect.ownKeys;
    sym = core.Symbol('c');
    assert.ok(toString$.call(ownKeys).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(ownKeys.length, 1, 'arity is 1');
    if ('name' in ownKeys) {
      assert.strictEqual(ownKeys.name, 'ownKeys', 'name is "ownKeys"');
    }
    O1 = {
      a: 1
    };
    defineProperty(O1, 'b', {
      value: 2
    });
    O1[sym] = 3;
    keys = ownKeys(O1);
    assert.strictEqual(keys.length, 3, 'ownKeys return all own keys');
    assert.ok(in$('a', keys), 'ownKeys return all own keys: simple');
    assert.ok(in$('b', keys), 'ownKeys return all own keys: hidden');
    assert.strictEqual(O1[keys[2]], 3, 'ownKeys return all own keys: symbol');
    O2 = clone$(O1);
    keys = ownKeys(O2);
    assert.strictEqual(keys.length, 0, 'ownKeys return only own keys');
    return assert.throws(function(){
      return ownKeys(42);
    }, TypeError, 'throws on primitive');
  });
  function in$(x, xs){
    var i = -1, l = xs.length >>> 0;
    while (++i < l) if (x === xs[i]) return true;
    return false;
  }
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, ref$, defineProperty, isExtensible, MODERN, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, isExtensible = ref$.isExtensible;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  test('Reflect.preventExtensions', function(assert){
    var preventExtensions, obj;
    preventExtensions = core.Reflect.preventExtensions;
    assert.ok(toString$.call(preventExtensions).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(preventExtensions.length, 1, 'arity is 1');
    if ('name' in preventExtensions) {
      assert.strictEqual(preventExtensions.name, 'preventExtensions', 'name is "preventExtensions"');
    }
    obj = {};
    assert.ok(preventExtensions(obj), true);
    if (MODERN) {
      assert.ok(!isExtensible(obj));
    }
    return assert.throws(function(){
      return preventExtensions(42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  if (Object.setPrototypeOf || '__proto__' in {}) {
    module = QUnit.module, test = QUnit.test;
    module('ES6');
    test('Reflect.setPrototypeOf', function(assert){
      var setPrototypeOf, obj, o;
      setPrototypeOf = core.Reflect.setPrototypeOf;
      assert.ok(toString$.call(setPrototypeOf).slice(8, -1) === 'Function', 'is function');
      if ('name' in setPrototypeOf) {
        assert.strictEqual(setPrototypeOf.name, 'setPrototypeOf', 'name is "setPrototypeOf"');
      }
      obj = {};
      assert.ok(setPrototypeOf(obj, Array.prototype), true);
      assert.ok(obj instanceof Array);
      assert.throws(function(){
        return setPrototypeOf({}, 42);
      }, TypeError);
      assert.throws(function(){
        return setPrototypeOf(42, {});
      }, TypeError, 'throws on primitive');
      return assert.ok(setPrototypeOf(o = {}, o) === false, 'false on recursive __proto__');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, ref$, defineProperty, getOwnPropertyDescriptor, create, MODERN, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  ref$ = core.Object, defineProperty = ref$.defineProperty, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, create = ref$.create;
  MODERN = function(){
    try {
      return 2 === defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  test('Reflect.set', function(assert){
    var set, obj, target, receiver, out;
    set = core.Reflect.set;
    assert.ok(toString$.call(set).slice(8, -1) === 'Function', 'is function');
    if ('name' in set) {
      assert.strictEqual(set.name, 'set', 'name is "set"');
    }
    obj = {};
    assert.ok(set(obj, 'quux', 654), true);
    assert.strictEqual(obj.quux, 654);
    target = {};
    receiver = {};
    set(target, 'foo', 1, receiver);
    assert.strictEqual(target.foo, void 8, 'target.foo === undefined');
    assert.strictEqual(receiver.foo, 1, 'receiver.foo === 1');
    if (MODERN) {
      defineProperty(receiver, 'bar', {
        value: 0,
        writable: true,
        enumerable: false,
        configurable: true
      });
      set(target, 'bar', 1, receiver);
      assert.strictEqual(receiver.bar, 1, 'receiver.bar === 1');
      assert.strictEqual(getOwnPropertyDescriptor(receiver, 'bar').enumerable, false, 'enumerability not overridden');
      target = create(defineProperty({
        z: 3
      }, 'w', {
        set: function(){
          out = this;
        }
      }), {
        x: {
          value: 1,
          writable: true,
          configurable: true
        },
        y: {
          set: function(){
            out = this;
          }
        },
        c: {
          value: 1,
          writable: false,
          configurable: false
        }
      });
      assert.strictEqual(set(target, 'x', 2, target), true, 'set x');
      assert.strictEqual(target.x, 2, 'set x');
      out = null;
      assert.strictEqual(set(target, 'y', 2, target), true, 'set y');
      assert.strictEqual(out, target, 'set y');
      assert.strictEqual(set(target, 'z', 4, target), true);
      assert.strictEqual(target.z, 4, 'set z');
      out = null;
      assert.strictEqual(set(target, 'w', 1, target), true, 'set w');
      assert.strictEqual(out, target, 'set w');
      assert.strictEqual(set(target, 'u', 0, target), true, 'set u');
      assert.strictEqual(target.u, 0, 'set u');
      assert.strictEqual(set(target, 'c', 2, target), false, 'set c');
      assert.strictEqual(target.c, 1, 'set c');
    }
    return assert.throws(function(){
      return set(42, 'q', 42);
    }, TypeError, 'throws on primitive');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, isIterator, same, Set, Symbol, ref$, getOwnPropertyDescriptor, freeze, values, from, iterator, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isIterator = function(it){
    return typeof it === 'object' && isFunction(it.next);
  };
  same = function(a, b){
    if (a === b) {
      return a !== 0 || 1 / a === 1 / b;
    } else {
      return a != a && b != b;
    }
  };
  Set = core.Set, Symbol = core.Symbol;
  ref$ = core.Object, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, freeze = ref$.freeze;
  ref$ = core.Array, values = ref$.values, from = ref$.from;
  iterator = core.Symbol.iterator;
  test('Set', function(assert){
    var S, r, done, iter, _add, a;
    assert.ok(isFunction(Set), 'is function');
    assert.ok('add' in Set.prototype, 'add in Set.prototype');
    assert.ok('clear' in Set.prototype, 'clear in Set.prototype');
    assert.ok('delete' in Set.prototype, 'delete in Set.prototype');
    assert.ok('forEach' in Set.prototype, 'forEach in Set.prototype');
    assert.ok('has' in Set.prototype, 'has in Set.prototype');
    assert.ok(new Set instanceof Set, 'new Set instanceof Set');
    assert.strictEqual(new Set(values([1, 2, 3, 2, 1])).size, 3, 'Init from iterator #1');
    assert.strictEqual(new Set([1, 2, 3, 2, 1]).size, 3, 'Init Set from iterator #2');
    assert.strictEqual(new Set([freeze({}), 1]).size, 2, 'Support frozen objects');
    S = new Set([1, 2, 3, 2, 1]);
    assert.strictEqual(S.size, 3);
    r = [];
    S.forEach(function(v){
      return r.push(v);
    });
    assert.deepEqual(r, [1, 2, 3]);
    assert.strictEqual(new Set([NaN, NaN, NaN]).size, 1);
    assert.deepEqual(from(new Set([3, 4]).add(2).add(1)), [3, 4, 2, 1]);
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    _add = Set.prototype.add;
    Set.prototype.add = function(){
      throw 42;
    };
    try {
      new Set(iter);
    } catch (e$) {}
    Set.prototype.add = _add;
    assert.ok(done, '.return #throw');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    new Set(a);
    return assert.ok(done);
  });
  test('Set#add', function(assert){
    var a, S, chain, f;
    assert.ok(isFunction(Set.prototype.add), 'is function');
    a = [];
    S = new Set([NaN, 2, 3, 2, 1, a]);
    assert.strictEqual(S.size, 5);
    chain = S.add(NaN);
    assert.strictEqual(chain, S);
    assert.strictEqual(S.size, 5);
    S.add(2);
    assert.strictEqual(S.size, 5);
    S.add(a);
    assert.strictEqual(S.size, 5);
    S.add([]);
    assert.strictEqual(S.size, 6);
    S.add(4);
    assert.strictEqual(S.size, 7);
    S = new Set().add(freeze(f = {}));
    return assert.ok(S.has(f));
  });
  test('Set#clear', function(assert){
    var S, f;
    assert.ok(isFunction(Set.prototype.clear), 'is function');
    S = new Set;
    S.clear();
    assert.strictEqual(S.size, 0);
    S = new Set([1, 2, 3, 2, 1]);
    S.clear();
    assert.strictEqual(S.size, 0);
    assert.ok(!S.has(1));
    assert.ok(!S.has(2));
    assert.ok(!S.has(3));
    S = new Set([1, f = freeze({})]);
    S.clear();
    assert.strictEqual(S.size, 0, 'Support frozen objects');
    assert.ok(!S.has(1));
    return assert.ok(!S.has(f));
  });
  test('Set#delete', function(assert){
    var a, S, f;
    assert.ok(isFunction(Set.prototype['delete']), 'is function');
    a = [];
    S = new Set([NaN, 2, 3, 2, 1, a]);
    assert.strictEqual(S.size, 5);
    assert.strictEqual(S['delete'](NaN), true);
    assert.strictEqual(S.size, 4);
    assert.strictEqual(S['delete'](4), false);
    assert.strictEqual(S.size, 4);
    S['delete']([]);
    assert.strictEqual(S.size, 4);
    S['delete'](a);
    assert.strictEqual(S.size, 3);
    S.add(freeze(f = {}));
    assert.strictEqual(S.size, 4);
    S['delete'](f);
    return assert.strictEqual(S.size, 3);
  });
  test('Set#forEach', function(assert){
    var r, count, S, set, s;
    assert.ok(isFunction(Set.prototype.forEach), 'is function');
    r = [];
    count = 0;
    S = new Set([1, 2, 3, 2, 1]);
    S.forEach(function(value){
      count++;
      r.push(value);
    });
    assert.strictEqual(count, 3);
    assert.deepEqual(r, [1, 2, 3]);
    set = new Set(['0', '1', '2', '3']);
    s = "";
    set.forEach(function(it){
      s += it;
      if (it === '2') {
        set['delete']('2');
        set['delete']('3');
        set['delete']('1');
        return set.add('4');
      }
    });
    assert.strictEqual(s, '0124');
    set = new Set(['0']);
    s = "";
    set.forEach(function(it){
      set['delete']('0');
      if (s !== '') {
        throw '!!!';
      }
      return s += it;
    });
    return assert.strictEqual(s, '0');
  });
  test('Set#has', function(assert){
    var a, f, S;
    assert.ok(isFunction(Set.prototype.has), 'is function');
    a = [];
    f = freeze({});
    S = new Set([NaN, 2, 3, 2, 1, f, a]);
    assert.ok(S.has(NaN));
    assert.ok(S.has(a));
    assert.ok(S.has(f));
    assert.ok(S.has(2));
    assert.ok(!S.has(4));
    return assert.ok(!S.has([]));
  });
  test('Set#size', function(assert){
    var size, sizeDesc;
    size = new Set([1]).size;
    assert.strictEqual(typeof size, 'number', 'size is number');
    assert.strictEqual(size, 1, 'size is correct');
    if (function(){
      try {
        return 2 === core.Object.defineProperty({}, 'a', {
          get: function(){
            return 2;
          }
        }).a;
      } catch (e$) {}
    }()) {
      sizeDesc = getOwnPropertyDescriptor(Set.prototype, 'size');
      assert.ok(sizeDesc && sizeDesc.get, 'size is getter');
      assert.ok(sizeDesc && !sizeDesc.set, 'size isnt setter');
      return assert.throws(function(){
        return Set.prototype.size;
      }, TypeError);
    }
  });
  test('Set & -0', function(assert){
    var set;
    set = new Set;
    set.add(-0);
    assert.strictEqual(set.size, 1);
    assert.ok(set.has(0));
    assert.ok(set.has(-0));
    set.forEach(function(it){
      return assert.ok(!same(it, -0));
    });
    set['delete'](-0);
    assert.strictEqual(set.size, 0);
    set = new Set([-0]);
    return set.forEach(function(key){
      return assert.ok(!same(key, -0));
    });
  });
  test('Set#@@toStringTag', function(assert){
    return assert.strictEqual(Set.prototype[Symbol != null ? Symbol.toStringTag : void 8], 'Set', 'Set::@@toStringTag is `Set`');
  });
  test('Set Iterator', function(assert){
    var set, keys, iterator;
    set = new Set(['a', 'b', 'c', 'd']);
    keys = [];
    iterator = set.keys();
    keys.push(iterator.next().value);
    assert.ok(set['delete']('a'));
    assert.ok(set['delete']('b'));
    assert.ok(set['delete']('c'));
    set.add('e');
    keys.push(iterator.next().value);
    keys.push(iterator.next().value);
    assert.ok(iterator.next().done);
    set.add('f');
    assert.ok(iterator.next().done);
    return assert.deepEqual(keys, ['a', 'd', 'e']);
  });
  test('Set#keys', function(assert){
    var iter;
    assert.ok(typeof Set.prototype.keys === 'function', 'is function');
    iter = new Set(['q', 'w', 'e']).keys();
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Set Iterator');
    assert.deepEqual(iter.next(), {
      value: 'q',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'w',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'e',
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Set#values', function(assert){
    var iter;
    assert.ok(typeof Set.prototype.values === 'function', 'is function');
    iter = new Set(['q', 'w', 'e']).values();
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Set Iterator');
    assert.deepEqual(iter.next(), {
      value: 'q',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'w',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'e',
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Set#entries', function(assert){
    var iter;
    assert.ok(typeof Set.prototype.entries === 'function', 'is function');
    iter = new Set(['q', 'w', 'e']).entries();
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Set Iterator');
    assert.deepEqual(iter.next(), {
      value: ['q', 'q'],
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: ['w', 'w'],
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: ['e', 'e'],
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
  test('Set#@@iterator', function(assert){
    var iter;
    iter = core.getIterator(new Set(['q', 'w', 'e']));
    assert.ok(isIterator(iter), 'Return iterator');
    assert.strictEqual(iter[Symbol != null ? Symbol.toStringTag : void 8], 'Set Iterator');
    assert.deepEqual(iter.next(), {
      value: 'q',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'w',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'e',
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('String#codePointAt', function(assert){
    var codePointAt;
    codePointAt = core.String.codePointAt;
    assert.ok(toString$.call(codePointAt).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', ''), 0x61);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', '_'), 0x61);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def'), 0x61);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', -Infinity), void 8);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', -1), void 8);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', -0), 0x61);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', 0), 0x61);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', 3), 0x1D306);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', 4), 0xDF06);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', 5), 0x64);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', 42), void 8);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', Infinity), void 8);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', Infinity), void 8);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', NaN), 0x61);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', false), 0x61);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', null), 0x61);
    assert.strictEqual(codePointAt('abc\uD834\uDF06def', void 8), 0x61);
    assert.strictEqual(codePointAt('\uD834\uDF06def', ''), 0x1D306);
    assert.strictEqual(codePointAt('\uD834\uDF06def', '1'), 0xDF06);
    assert.strictEqual(codePointAt('\uD834\uDF06def', '_'), 0x1D306);
    assert.strictEqual(codePointAt('\uD834\uDF06def'), 0x1D306);
    assert.strictEqual(codePointAt('\uD834\uDF06def', -1), void 8);
    assert.strictEqual(codePointAt('\uD834\uDF06def', -0), 0x1D306);
    assert.strictEqual(codePointAt('\uD834\uDF06def', 0), 0x1D306);
    assert.strictEqual(codePointAt('\uD834\uDF06def', 1), 0xDF06);
    assert.strictEqual(codePointAt('\uD834\uDF06def', 42), void 8);
    assert.strictEqual(codePointAt('\uD834\uDF06def', false), 0x1D306);
    assert.strictEqual(codePointAt('\uD834\uDF06def', null), 0x1D306);
    assert.strictEqual(codePointAt('\uD834\uDF06def', void 8), 0x1D306);
    assert.strictEqual(codePointAt('\uD834abc', ''), 0xD834);
    assert.strictEqual(codePointAt('\uD834abc', '_'), 0xD834);
    assert.strictEqual(codePointAt('\uD834abc'), 0xD834);
    assert.strictEqual(codePointAt('\uD834abc', -1), void 8);
    assert.strictEqual(codePointAt('\uD834abc', -0), 0xD834);
    assert.strictEqual(codePointAt('\uD834abc', 0), 0xD834);
    assert.strictEqual(codePointAt('\uD834abc', false), 0xD834);
    assert.strictEqual(codePointAt('\uD834abc', NaN), 0xD834);
    assert.strictEqual(codePointAt('\uD834abc', null), 0xD834);
    assert.strictEqual(codePointAt('\uD834abc', void 8), 0xD834);
    assert.strictEqual(codePointAt('\uDF06abc', ''), 0xDF06);
    assert.strictEqual(codePointAt('\uDF06abc', '_'), 0xDF06);
    assert.strictEqual(codePointAt('\uDF06abc'), 0xDF06);
    assert.strictEqual(codePointAt('\uDF06abc', -1), void 8);
    assert.strictEqual(codePointAt('\uDF06abc', -0), 0xDF06);
    assert.strictEqual(codePointAt('\uDF06abc', 0), 0xDF06);
    assert.strictEqual(codePointAt('\uDF06abc', false), 0xDF06);
    assert.strictEqual(codePointAt('\uDF06abc', NaN), 0xDF06);
    assert.strictEqual(codePointAt('\uDF06abc', null), 0xDF06);
    assert.strictEqual(codePointAt('\uDF06abc', void 8), 0xDF06);
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return codePointAt(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return codePointAt(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('String#endsWith', function(assert){
    var endsWith, re, ref$, e, O, ref1$;
    endsWith = core.String.endsWith;
    assert.ok(toString$.call(endsWith).slice(8, -1) === 'Function', 'is function');
    assert.ok(endsWith('undefined'));
    assert.ok(!endsWith('undefined', null));
    assert.ok(endsWith('abc', ''));
    assert.ok(endsWith('abc', 'c'));
    assert.ok(endsWith('abc', 'bc'));
    assert.ok(!endsWith('abc', 'ab'));
    assert.ok(endsWith('abc', '', NaN));
    assert.ok(!endsWith('abc', 'c', -1));
    assert.ok(endsWith('abc', 'a', 1));
    assert.ok(endsWith('abc', 'c', Infinity));
    assert.ok(endsWith('abc', 'a', true));
    assert.ok(!endsWith('abc', 'c', 'x'));
    assert.ok(!endsWith('abc', 'a', 'x'));
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return endsWith(null, '.');
      }, TypeError);
      assert.throws(function(){
        return endsWith(void 8, '.');
      }, TypeError);
    }
    re = /./;
    assert.throws(function(){
      return endsWith('/./', re);
    }, TypeError);
    re[(ref$ = core.Symbol) != null ? ref$.match : void 8] = false;
    assert.ok((function(){
      try {
        return endsWith('/./', re);
      } catch (e$) {
        e = e$;
        return false;
      }
    }()));
    O = {};
    assert.ok((function(){
      try {
        return endsWith('[object Object]', O);
      } catch (e$) {
        e = e$;
        return false;
      }
    }()));
    O[(ref1$ = core.Symbol) != null ? ref1$.match : void 8] = true;
    return assert.throws(function(){
      return endsWith('[object Object]', O);
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('String.fromCodePoint', function(assert){
    var fromCodePoint, tmp, counter, result;
    fromCodePoint = core.String.fromCodePoint;
    assert.ok(toString$.call(fromCodePoint).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(fromCodePoint.length, 1, 'arity is 1');
    if ('name' in fromCodePoint) {
      assert.strictEqual(fromCodePoint.name, 'fromCodePoint', 'name is "fromCodePoint"');
    }
    assert.strictEqual(fromCodePoint(''), '\0');
    assert.strictEqual(fromCodePoint(), '');
    assert.strictEqual(fromCodePoint(-0), '\0');
    assert.strictEqual(fromCodePoint(0), '\0');
    assert.strictEqual(fromCodePoint(0x1D306), '\uD834\uDF06');
    assert.strictEqual(fromCodePoint(0x1D306, 0x61, 0x1D307), '\uD834\uDF06a\uD834\uDF07');
    assert.strictEqual(fromCodePoint(0x61, 0x62, 0x1D307), 'ab\uD834\uDF07');
    assert.strictEqual(fromCodePoint(false), '\0');
    assert.strictEqual(fromCodePoint(null), '\0');
    assert.throws(function(){
      return fromCodePoint('_');
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint('+Infinity');
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint('-Infinity');
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint(-1);
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint(0x10FFFF + 1);
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint(3.14);
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint(3e-2);
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint(-Infinity);
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint(Infinity);
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint(NaN);
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint(void 8);
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint({});
    }, RangeError);
    assert.throws(function(){
      return fromCodePoint(/./);
    }, RangeError);
    tmp = 0x60;
    assert.strictEqual(fromCodePoint({
      valueOf: function(){
        return ++tmp;
      }
    }), 'a');
    assert.strictEqual(tmp, 0x61);
    counter = Math.pow(2, 15) * 3 / 2;
    result = [];
    while (--counter >= 0) {
      result.push(0);
    }
    fromCodePoint.apply(null, result);
    counter = Math.pow(2, 15) * 3 / 2;
    result = [];
    while (--counter >= 0) {
      result.push(0xFFFF + 1);
    }
    return fromCodePoint.apply(null, result);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('String#includes', function(assert){
    var includes, re, ref$, e, O, ref1$;
    includes = core.String.includes;
    assert.ok(toString$.call(includes).slice(8, -1) === 'Function', 'is function');
    assert.ok(!includes('abc'));
    assert.ok(includes('aundefinedb'));
    assert.ok(includes('abcd', 'b', 1));
    assert.ok(!includes('abcd', 'b', 2));
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return includes(null, '.');
      }, TypeError);
      assert.throws(function(){
        return includes(void 8, '.');
      }, TypeError);
    }
    re = /./;
    assert.throws(function(){
      return includes('/./', re);
    }, TypeError);
    re[(ref$ = core.Symbol) != null ? ref$.match : void 8] = false;
    assert.ok((function(){
      try {
        return includes('/./', re);
      } catch (e$) {
        e = e$;
        return false;
      }
    }()));
    O = {};
    assert.ok((function(){
      try {
        return includes('[object Object]', O);
      } catch (e$) {
        e = e$;
        return false;
      }
    }()));
    O[(ref1$ = core.Symbol) != null ? ref1$.match : void 8] = true;
    return assert.throws(function(){
      return includes('[object Object]', O);
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isIterator, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  isIterator = function(it){
    return typeof it === 'object' && toString$.call(it.next).slice(8, -1) === 'Function';
  };
  test('String#@@iterator', function(assert){
    var iter, ref$;
    iter = core.getIterator('qwe');
    assert.strictEqual(iter[(ref$ = core.Symbol) != null ? ref$.toStringTag : void 8], 'String Iterator');
    assert.deepEqual(iter.next(), {
      value: 'q',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'w',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: 'e',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
    assert.strictEqual(core.Array.from('𠮷𠮷𠮷').length, 3);
    iter = core.getIterator('𠮷𠮷𠮷');
    assert.deepEqual(iter.next(), {
      value: '𠮷',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: '𠮷',
      done: false
    });
    assert.deepEqual(iter.next(), {
      value: '𠮷',
      done: false
    });
    return assert.deepEqual(iter.next(), {
      value: void 8,
      done: true
    });
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('String.raw', function(assert){
    var raw;
    raw = core.String.raw;
    assert.ok(toString$.call(raw).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(raw.length, 1, 'arity is 1');
    if ('name' in raw) {
      assert.strictEqual(raw.name, 'raw', 'name is "raw"');
    }
    assert.strictEqual(raw({
      raw: ['Hi\\n', '!']
    }, 'Bob'), 'Hi\\nBob!', 'raw is array');
    assert.strictEqual(raw({
      raw: 'test'
    }, 0, 1, 2), 't0e1s2t', 'raw is string');
    assert.strictEqual(raw({
      raw: 'test'
    }, 0), 't0est', 'lacks substituting');
    assert.throws(function(){
      return raw({});
    }, TypeError);
    return assert.throws(function(){
      return raw({
        raw: null
      });
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('String#repeat', function(assert){
    var repeat;
    repeat = core.String.repeat;
    assert.ok(toString$.call(repeat).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(repeat('qwe', 3), 'qweqweqwe');
    assert.strictEqual(repeat('qwe', 2.5), 'qweqwe');
    assert.throws(function(){
      return repeat('qwe', -1);
    }, RangeError);
    assert.throws(function(){
      return repeat('qwe', Infinity);
    }, RangeError);
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return repeat(null, 1);
      }, TypeError);
      return assert.throws(function(){
        return repeat(void 8, 1);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('String#startsWith', function(assert){
    var startsWith, re, ref$, e, O, ref1$;
    startsWith = core.String.startsWith;
    assert.ok(toString$.call(startsWith).slice(8, -1) === 'Function', 'is function');
    assert.ok(startsWith('undefined'));
    assert.ok(!startsWith('undefined', null));
    assert.ok(startsWith('abc', ''));
    assert.ok(startsWith('abc', 'a'));
    assert.ok(startsWith('abc', 'ab'));
    assert.ok(!startsWith('abc', 'bc'));
    assert.ok(startsWith('abc', '', NaN));
    assert.ok(startsWith('abc', 'a', -1));
    assert.ok(!startsWith('abc', 'a', 1));
    assert.ok(!startsWith('abc', 'a', Infinity));
    assert.ok(startsWith('abc', 'b', true));
    assert.ok(startsWith('abc', 'a', 'x'));
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return startsWith(null, '.');
      }, TypeError);
      assert.throws(function(){
        return startsWith(void 8, '.');
      }, TypeError);
    }
    re = /./;
    assert.throws(function(){
      return startsWith('/./', re);
    }, TypeError);
    re[(ref$ = core.Symbol) != null ? ref$.match : void 8] = false;
    assert.ok((function(){
      try {
        return startsWith('/./', re);
      } catch (e$) {
        e = e$;
        return false;
      }
    }()));
    O = {};
    assert.ok((function(){
      try {
        return startsWith('[object Object]', O);
      } catch (e$) {
        e = e$;
        return false;
      }
    }()));
    O[(ref1$ = core.Symbol) != null ? ref1$.match : void 8] = true;
    return assert.throws(function(){
      return startsWith('[object Object]', O);
    }, TypeError);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  test('String#trim', function(assert){
    var trim;
    trim = core.String.trim;
    assert.ok(toString$.call(trim).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(trim(' \n  q w e \n  '), 'q w e', 'removes whitespaces at left & right side of string');
    assert.strictEqual(trim('\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF'), '', 'removes all whitespaces');
    assert.strictEqual(trim('\u200b\u0085'), '\u200b\u0085', "shouldn't remove this symbols");
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return trim(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return trim(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, Symbol, JSON, ref$, defineProperty, getOwnPropertyDescriptor, create, isFunction, isNative, descriptors, G, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  Symbol = core.Symbol, JSON = core.JSON;
  ref$ = core.Object, defineProperty = ref$.defineProperty, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, create = ref$.create;
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  isNative = function(it){
    return /\[native code\]\s*\}\s*$/.test(it);
  };
  descriptors = function(){
    try {
      return 2 === core.Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  G = (typeof global != 'undefined' && global !== null) && global || window;
  test('Symbol', function(assert){
    var s1, s2, O, count, i;
    assert.ok(isFunction(Symbol), 'is function');
    s1 = Symbol('foo');
    s2 = Symbol('foo');
    assert.ok(s1 !== s2, 'Symbol("foo") !== Symbol("foo")');
    O = {};
    O[s1] = 42;
    assert.ok(O[s1] === 42, 'Symbol() work as key');
    assert.ok(O[s2] !== 42, 'Various symbols from one description are various keys');
    if (descriptors) {
      count = 0;
      for (i in O) {
        count++;
      }
      return assert.ok(count === 0, 'object[Symbol()] is not enumerable');
    }
  });
  test('Well-known Symbols', function(assert){
    var i$, x$, ref$, len$, results$ = [];
    for (i$ = 0, len$ = (ref$ = ['hasInstance', 'isConcatSpreadable', 'iterator', 'match', 'replace', 'search', 'species', 'split', 'toPrimitive', 'toStringTag', 'unscopables']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      assert.ok(x$ in Symbol, "Symbol." + x$ + " available");
      results$.push(assert.ok(Object(Symbol[x$]) instanceof Symbol, "Symbol." + x$ + " is symbol"));
    }
    return results$;
  });
  test('Global symbol registry', function(assert){
    var symbol;
    assert.ok(isFunction(Symbol['for']), 'Symbol.for is function');
    assert.ok(isFunction(Symbol.keyFor), 'Symbol.keyFor is function');
    symbol = Symbol['for']('foo');
    assert.strictEqual(Symbol['for']('foo'), symbol);
    return assert.strictEqual(Symbol.keyFor(symbol), 'foo');
  });
  test('Symbol#@@toStringTag', function(assert){
    return assert.ok(Symbol.prototype[Symbol.toStringTag] === 'Symbol', 'Symbol::@@toStringTag is `Symbol`');
  });
  test('Object.getOwnPropertySymbols', function(assert){
    var ref$, getOwnPropertySymbols, getOwnPropertyNames, obj, foo;
    ref$ = core.Object, getOwnPropertySymbols = ref$.getOwnPropertySymbols, getOwnPropertyNames = ref$.getOwnPropertyNames;
    assert.ok(isFunction(getOwnPropertySymbols), 'is function');
    obj = {
      q: 1,
      w: 2,
      e: 3
    };
    obj[Symbol()] = 42;
    obj[Symbol()] = 43;
    assert.deepEqual(getOwnPropertyNames(obj).sort(), ['e', 'q', 'w']);
    assert.strictEqual(getOwnPropertySymbols(obj).length, 2);
    foo = (ref$ = clone$(obj), ref$.a = 1, ref$.s = 2, ref$.d = 3, ref$);
    foo[Symbol()] = 44;
    assert.deepEqual(getOwnPropertyNames(foo).sort(), ['a', 'd', 's']);
    return assert.strictEqual(getOwnPropertySymbols(foo).length, 1);
  });
  if (JSON != null) {
    test('Symbols & JSON.stringify', function(assert){
      var ref$;
      assert.strictEqual(JSON.stringify([1, Symbol('foo'), false, Symbol('bar'), {}]), '[1,null,false,null,{}]', 'array value');
      assert.strictEqual(JSON.stringify({
        foo: Symbol('foo')
      }), '{}', 'object value');
      if (descriptors) {
        assert.strictEqual(JSON.stringify((ref$ = {}, ref$[Symbol('foo')] = 1, ref$.bar = 2, ref$)), '{"bar":2}', 'object key');
      }
      assert.strictEqual(JSON.stringify(Symbol('foo')), void 8, 'symbol value');
      if (typeof Symbol() === 'symbol') {
        return assert.strictEqual(JSON.stringify(Object(Symbol('foo'))), '{}', 'boxed symbol');
      }
    });
  }
  if (descriptors) {
    test('Symbols & descriptors', function(assert){
      var ref$, create, defineProperty, getOwnPropertyDescriptor, keys, getOwnPropertyNames, getOwnPropertySymbols, d, e, f, i, j, proto, O, desc;
      ref$ = core.Object, create = ref$.create, defineProperty = ref$.defineProperty, getOwnPropertyDescriptor = ref$.getOwnPropertyDescriptor, keys = ref$.keys, getOwnPropertyNames = ref$.getOwnPropertyNames, getOwnPropertySymbols = ref$.getOwnPropertySymbols;
      d = Symbol('d');
      e = Symbol('e');
      f = Symbol('f');
      i = Symbol('i');
      j = Symbol('j');
      proto = (ref$ = {
        g: 'g'
      }, ref$[i] = 'i', ref$);
      defineProperty(proto, 'h', {
        value: 'h'
      });
      defineProperty(proto, 'j', {
        value: 'j'
      });
      O = create(proto);
      O.a = 'a';
      O[d] = 'd';
      defineProperty(O, 'b', {
        value: 'b'
      });
      defineProperty(O, 'c', {
        value: 'c',
        enumerable: true
      });
      defineProperty(O, e, {
        configurable: true,
        writable: true,
        value: 'e'
      });
      desc = {
        value: 'f',
        enumerable: true
      };
      defineProperty(O, f, desc);
      assert.strictEqual(desc.enumerable, true, 'defineProperty not changes descriptor object');
      assert.deepEqual(getOwnPropertyDescriptor(O, 'a'), {
        configurable: true,
        writable: true,
        enumerable: true,
        value: 'a'
      }, 'getOwnPropertyDescriptor a');
      assert.deepEqual(getOwnPropertyDescriptor(O, 'b'), {
        configurable: false,
        writable: false,
        enumerable: false,
        value: 'b'
      }, 'getOwnPropertyDescriptor b');
      assert.deepEqual(getOwnPropertyDescriptor(O, 'c'), {
        configurable: false,
        writable: false,
        enumerable: true,
        value: 'c'
      }, 'getOwnPropertyDescriptor c');
      assert.deepEqual(getOwnPropertyDescriptor(O, d), {
        configurable: true,
        writable: true,
        enumerable: true,
        value: 'd'
      }, 'getOwnPropertyDescriptor d');
      assert.deepEqual(getOwnPropertyDescriptor(O, e), {
        configurable: true,
        writable: true,
        enumerable: false,
        value: 'e'
      }, 'getOwnPropertyDescriptor e');
      assert.deepEqual(getOwnPropertyDescriptor(O, f), {
        configurable: false,
        writable: false,
        enumerable: true,
        value: 'f'
      }, 'getOwnPropertyDescriptor f');
      assert.strictEqual(getOwnPropertyDescriptor(O, 'g'), void 8, 'getOwnPropertyDescriptor g');
      assert.strictEqual(getOwnPropertyDescriptor(O, 'h'), void 8, 'getOwnPropertyDescriptor h');
      assert.strictEqual(getOwnPropertyDescriptor(O, i), void 8, 'getOwnPropertyDescriptor i');
      assert.strictEqual(getOwnPropertyDescriptor(O, j), void 8, 'getOwnPropertyDescriptor j');
      assert.strictEqual(getOwnPropertyDescriptor(O, 'k'), void 8, 'getOwnPropertyDescriptor k');
      assert.strictEqual(keys(O).length, 2, 'Object.keys');
      assert.strictEqual(getOwnPropertyNames(O).length, 3, 'Object.getOwnPropertyNames');
      assert.strictEqual(getOwnPropertySymbols(O).length, 3, 'Object.getOwnPropertySymbols');
      assert.strictEqual(core.Reflect.ownKeys(O).length, 6, 'Reflect.ownKeys');
      delete O[e];
      O[e] = 'e';
      return assert.deepEqual(getOwnPropertyDescriptor(O, e), {
        configurable: true,
        writable: true,
        enumerable: true,
        value: 'e'
      }, 'redefined non-enum key');
    });
    test('Symbols & Object.defineProperties', function(assert){
      var ref$, defineProperty, defineProperties, c, d, D, O;
      ref$ = core.Object, defineProperty = ref$.defineProperty, defineProperties = ref$.defineProperties;
      c = core.Symbol('c');
      d = core.Symbol('d');
      D = (ref$ = {
        a: {
          value: 'a'
        }
      }, ref$[c] = {
        value: 'c'
      }, ref$);
      defineProperty(D, 'b', {
        value: {
          value: 'b'
        }
      });
      defineProperty(D, d, {
        value: {
          value: 'd'
        }
      });
      O = defineProperties({}, D);
      assert.strictEqual(O.a, 'a', 'a');
      assert.strictEqual(O.b, void 8, 'b');
      assert.strictEqual(O[c], 'c', 'c');
      return assert.strictEqual(O[d], void 8, 'd');
    });
    test('Symbols & Object.create', function(assert){
      var ref$, defineProperty, create, c, d, D, O;
      ref$ = core.Object, defineProperty = ref$.defineProperty, create = ref$.create;
      c = core.Symbol('c');
      d = core.Symbol('d');
      D = (ref$ = {
        a: {
          value: 'a'
        }
      }, ref$[c] = {
        value: 'c'
      }, ref$);
      defineProperty(D, 'b', {
        value: {
          value: 'b'
        }
      });
      defineProperty(D, d, {
        value: {
          value: 'd'
        }
      });
      O = create(null, D);
      assert.strictEqual(O.a, 'a', 'a');
      assert.strictEqual(O.b, void 8, 'b');
      assert.strictEqual(O[c], 'c', 'c');
      return assert.strictEqual(O[d], void 8, 'd');
    });
  }
  function clone$(it){
    function fun(){} fun.prototype = it;
    return new fun;
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, WeakMap, Map, freeze, values, iterator, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  WeakMap = core.WeakMap, Map = core.Map;
  freeze = core.Object.freeze;
  values = core.Array.values;
  iterator = core.Symbol.iterator;
  test('WeakMap', function(assert){
    var a, b, f, M, done, iter;
    assert.ok(isFunction(WeakMap), 'is function');
    assert.ok('delete' in WeakMap.prototype, 'delete in WeakMap.prototype');
    assert.ok('get' in WeakMap.prototype, 'get in WeakMap.prototype');
    assert.ok('has' in WeakMap.prototype, 'has in WeakMap.prototype');
    assert.ok('set' in WeakMap.prototype, 'set in WeakMap.prototype');
    assert.ok(new WeakMap instanceof WeakMap, 'new WeakMap instanceof WeakMap');
    assert.strictEqual(new WeakMap(values([[a = {}, b = {}]])).get(a), b, 'Init WeakMap from iterator #1');
    assert.strictEqual(new WeakMap(new Map([[a = {}, b = {}]])).get(a), b, 'Init WeakMap from iterator #2');
    assert.strictEqual(new WeakMap([[f = freeze({}), 42]]).get(f), 42, 'Support frozen objects');
    M = new WeakMap;
    M.set(freeze(f = {}), 42);
    assert.strictEqual(M.has(f), true, 'works with frozen objects, #1');
    assert.strictEqual(M.get(f), 42, 'works with frozen objects, #2');
    M['delete'](f);
    assert.strictEqual(M.has(f), false, 'works with frozen objects, #3');
    assert.strictEqual(M.get(f), void 8, 'works with frozen objects, #4');
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      new WeakMap(iter);
    } catch (e$) {}
    assert.ok(done, '.return #throw');
    assert.ok(!('clear' in WeakMap.prototype), 'should not contains `.clear` method');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    new WeakMap(a);
    return assert.ok(done);
  });
  test('WeakMap#delete', function(assert){
    var M, a, b;
    assert.ok(isFunction(WeakMap.prototype['delete']), 'is function');
    M = new WeakMap([[a = {}, 42], [b = {}, 21]]);
    assert.ok(M.has(a) && M.has(b), 'WeakMap has values before .delete()');
    M['delete'](a);
    return assert.ok(!M.has(a) && M.has(b), 'WeakMap hasn`t value after .delete()');
  });
  test('WeakMap#get', function(assert){
    var M, a;
    assert.ok(isFunction(WeakMap.prototype.get), 'is function');
    M = new WeakMap();
    assert.strictEqual(M.get({}), void 8, 'WeakMap .get() before .set() return undefined');
    M.set(a = {}, 42);
    assert.strictEqual(M.get(a), 42, 'WeakMap .get() return value');
    M['delete'](a);
    return assert.strictEqual(M.get(a), void 8, 'WeakMap .get() after .delete() return undefined');
  });
  test('WeakMap#has', function(assert){
    var M, a;
    assert.ok(isFunction(WeakMap.prototype.has), 'is function');
    M = new WeakMap();
    assert.ok(!M.has({}), 'WeakMap .has() before .set() return false');
    M.set(a = {}, 42);
    assert.ok(M.has(a), 'WeakMap .has() return true');
    M['delete'](a);
    return assert.ok(!M.has(a), 'WeakMap .has() after .delete() return false');
  });
  test('WeakMap#set', function(assert){
    var w, a, e;
    assert.ok(isFunction(WeakMap.prototype.set), 'is function');
    assert.ok((w = new WeakMap).set(a = {}, 42) === w, 'chaining');
    return assert.ok((function(){
      try {
        new WeakMap().set(42, 42);
        return false;
      } catch (e$) {
        e = e$;
        return true;
      }
    }()), 'throws with primitive keys');
  });
  test('WeakMap#@@toStringTag', function(assert){
    var ref$;
    return assert.strictEqual(WeakMap.prototype[(ref$ = core.Symbol) != null ? ref$.toStringTag : void 8], 'WeakMap', 'WeakMap::@@toStringTag is `WeakMap`');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, WeakSet, freeze, values, iterator, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES6');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  WeakSet = core.WeakSet;
  freeze = core.Object.freeze;
  values = core.Array.values;
  iterator = core.Symbol.iterator;
  test('WeakSet', function(assert){
    var a, f, S, done, iter;
    assert.ok(isFunction(WeakSet), 'is function');
    assert.ok('add' in WeakSet.prototype, 'add in WeakSet.prototype');
    assert.ok('delete' in WeakSet.prototype, 'delete in WeakSet.prototype');
    assert.ok('has' in WeakSet.prototype, 'has in WeakSet.prototype');
    assert.ok(new WeakSet instanceof WeakSet, 'new WeakSet instanceof WeakSet');
    assert.ok(new WeakSet(values([a = {}])).has(a), 'Init WeakSet from iterator #1');
    assert.ok(new WeakSet([a = {}]).has(a), 'Init WeakSet from iterator #2');
    assert.ok(new WeakSet([freeze(f = {})]).has(f), 'Support frozen objects');
    S = new WeakSet;
    S.add(freeze(f = {}));
    assert.strictEqual(S.has(f), true, 'works with frozen objects, #1');
    S['delete'](f);
    assert.strictEqual(S.has(f), false, 'works with frozen objects, #2');
    done = false;
    iter = values([null, 1, 2]);
    iter['return'] = function(){
      return done = true;
    };
    try {
      new WeakSet(iter);
    } catch (e$) {}
    assert.ok(done, '.return #throw');
    assert.ok(!('clear' in WeakSet.prototype), 'should not contains `.clear` method');
    a = [];
    done = false;
    a['@@iterator'] = void 8;
    a[iterator] = function(){
      done = true;
      return core.getIteratorMethod([]).call(this);
    };
    new WeakSet(a);
    return assert.ok(done);
  });
  test('WeakSet#add', function(assert){
    var w, e;
    assert.ok(isFunction(WeakSet.prototype.add), 'is function');
    assert.ok((w = new WeakSet).add({}) === w, 'chaining');
    return assert.ok((function(){
      try {
        new WeakSet().add(42);
        return false;
      } catch (e$) {
        e = e$;
        return true;
      }
    }()), 'throws with primitive keys');
  });
  test('WeakSet#delete', function(assert){
    var S, a, b;
    assert.ok(isFunction(WeakSet.prototype['delete']), 'is function');
    S = new WeakSet().add(a = {}).add(b = {});
    assert.ok(S.has(a) && S.has(b), 'WeakSet has values before .delete()');
    S['delete'](a);
    return assert.ok(!S.has(a) && S.has(b), 'WeakSet has`nt value after .delete()');
  });
  test('WeakSet#has', function(assert){
    var M, a;
    assert.ok(isFunction(WeakSet.prototype.has), 'is function');
    M = new WeakSet();
    assert.ok(!M.has({}), 'WeakSet has`nt value');
    M.add(a = {});
    assert.ok(M.has(a), 'WeakSet has value after .add()');
    M['delete'](a);
    return assert.ok(!M.has(a), 'WeakSet has`nt value after .delete()');
  });
  test('WeakSet::@@toStringTag', function(assert){
    var ref$;
    return assert.strictEqual(WeakSet.prototype[(ref$ = core.Symbol) != null ? ref$.toStringTag : void 8], 'WeakSet', 'WeakSet::@@toStringTag is `WeakSet`');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  test('Array#includes', function(assert){
    var includes, arr, o;
    includes = core.Array.includes;
    assert.ok(toString$.call(includes).slice(8, -1) === 'Function', 'is function');
    arr = [1, 2, 3, -0, o = {}];
    assert.ok(includes(arr, 1));
    assert.ok(includes(arr, -0));
    assert.ok(includes(arr, 0));
    assert.ok(includes(arr, o));
    assert.ok(!includes(arr, 4));
    assert.ok(!includes(arr, -0.5));
    assert.ok(!includes(arr, {}));
    assert.ok(includes(Array(1), void 8));
    assert.ok(includes([NaN], NaN));
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return includes(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return includes(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  test('Object.entries', function(assert){
    var ref$, entries, create, assign;
    ref$ = core.Object, entries = ref$.entries, create = ref$.create, assign = ref$.assign;
    assert.ok(toString$.call(entries).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(entries.length, 1, 'arity is 1');
    if ('name' in entries) {
      assert.strictEqual(entries.name, 'entries', 'name is "entries"');
    }
    assert.deepEqual(entries({
      q: 1,
      w: 2,
      e: 3
    }), [['q', 1], ['w', 2], ['e', 3]]);
    assert.deepEqual(entries(new String('qwe')), [['0', 'q'], ['1', 'w'], ['2', 'e']]);
    assert.deepEqual(entries(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    })), [['a', 4], ['s', 5], ['d', 6]]);
    try {
      return assert.deepEqual(Function('return core.Object.entries({a: 1, get b(){delete this.c;return 2},c: 3})')(), [['a', 1], ['b', 2]]);
    } catch (e$) {}
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, descriptors, create, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  descriptors = function(){
    try {
      return 2 === core.Object.defineProperty({}, 'a', {
        get: function(){
          return 2;
        }
      }).a;
    } catch (e$) {}
  }();
  create = core.Object.create;
  test('Object.getOwnPropertyDescriptors', function(assert){
    var getOwnPropertyDescriptors, O, s, descs;
    getOwnPropertyDescriptors = core.Object.getOwnPropertyDescriptors;
    assert.ok(toString$.call(getOwnPropertyDescriptors).slice(8, -1) === 'Function', 'is function');
    O = create({
      q: 1
    }, {
      e: {
        value: 3
      }
    });
    O.w = 2;
    s = core.Symbol('s');
    O[s] = 4;
    descs = getOwnPropertyDescriptors(O);
    assert.strictEqual(descs.q, void 8);
    assert.deepEqual(descs.w, {
      enumerable: true,
      configurable: true,
      writable: true,
      value: 2
    });
    if (descriptors) {
      assert.deepEqual(descs.e, {
        enumerable: false,
        configurable: false,
        writable: false,
        value: 3
      });
    } else {
      assert.deepEqual(descs.e, {
        enumerable: true,
        configurable: true,
        writable: true,
        value: 3
      });
    }
    return assert.strictEqual(descs[s].value, 4);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  test('Object.values', function(assert){
    var ref$, values, create, assign;
    ref$ = core.Object, values = ref$.values, create = ref$.create, assign = ref$.assign;
    assert.ok(toString$.call(values).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(values.length, 1, 'arity is 1');
    if ('name' in values) {
      assert.strictEqual(values.name, 'values', 'name is "values"');
    }
    assert.deepEqual(values({
      q: 1,
      w: 2,
      e: 3
    }), [1, 2, 3]);
    assert.deepEqual(values(new String('qwe')), ['q', 'w', 'e']);
    assert.deepEqual(values(assign(create({
      q: 1,
      w: 2,
      e: 3
    }), {
      a: 4,
      s: 5,
      d: 6
    })), [4, 5, 6]);
    try {
      return assert.deepEqual(Function('return core.Object.values({a: 1, get b(){delete this.c;return 2},c: 3})')(), [1, 2]);
    } catch (e$) {}
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  test('RegExp.escape', function(assert){
    var escape;
    escape = core.RegExp.escape;
    assert.ok(toString$.call(escape).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(escape('qwe asd'), 'qwe asd', "Don't change simple string");
    return assert.strictEqual(escape('\\[]{}()*+?.^$|'), '\\\\\\[\\]\\{\\}\\(\\)\\*\\+\\?\\.\\^\\$\\|', 'Escape all RegExp special chars');
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  test('String#at', function(assert){
    var at;
    at = core.String.at;
    assert.ok(toString$.call(at).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(at('abc\uD834\uDF06def', -Infinity), '');
    assert.strictEqual(at('abc\uD834\uDF06def', -1), '');
    assert.strictEqual(at('abc\uD834\uDF06def', -0), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', +0), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', 1), 'b');
    assert.strictEqual(at('abc\uD834\uDF06def', 3), '\uD834\uDF06');
    assert.strictEqual(at('abc\uD834\uDF06def', 4), '\uDF06');
    assert.strictEqual(at('abc\uD834\uDF06def', 5), 'd');
    assert.strictEqual(at('abc\uD834\uDF06def', 42), '');
    assert.strictEqual(at('abc\uD834\uDF06def', Infinity), '');
    assert.strictEqual(at('abc\uD834\uDF06def', null), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', void 8), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def'), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', false), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', NaN), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', ''), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', '_'), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', '1'), 'b');
    assert.strictEqual(at('abc\uD834\uDF06def', []), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', {}), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', -0.9), 'a');
    assert.strictEqual(at('abc\uD834\uDF06def', 1.9), 'b');
    assert.strictEqual(at('abc\uD834\uDF06def', 7.9), 'f');
    assert.strictEqual(at('abc\uD834\uDF06def', Math.pow(2, 32)), '');
    assert.strictEqual(at('\uD834\uDF06def', -Infinity), '');
    assert.strictEqual(at('\uD834\uDF06def', -1), '');
    assert.strictEqual(at('\uD834\uDF06def', -0), '\uD834\uDF06');
    assert.strictEqual(at('\uD834\uDF06def', 0), '\uD834\uDF06');
    assert.strictEqual(at('\uD834\uDF06def', 1), '\uDF06');
    assert.strictEqual(at('\uD834\uDF06def', 2), 'd');
    assert.strictEqual(at('\uD834\uDF06def', 3), 'e');
    assert.strictEqual(at('\uD834\uDF06def', 4), 'f');
    assert.strictEqual(at('\uD834\uDF06def', 42), '');
    assert.strictEqual(at('\uD834\uDF06def', Infinity), '');
    assert.strictEqual(at('\uD834\uDF06def', null), '\uD834\uDF06');
    assert.strictEqual(at('\uD834\uDF06def', void 8), '\uD834\uDF06');
    assert.strictEqual(at('\uD834\uDF06def'), '\uD834\uDF06');
    assert.strictEqual(at('\uD834\uDF06def', false), '\uD834\uDF06');
    assert.strictEqual(at('\uD834\uDF06def', NaN), '\uD834\uDF06');
    assert.strictEqual(at('\uD834\uDF06def', ''), '\uD834\uDF06');
    assert.strictEqual(at('\uD834\uDF06def', '_'), '\uD834\uDF06');
    assert.strictEqual(at('\uD834\uDF06def', '1'), '\uDF06');
    assert.strictEqual(at('\uD834abc', -Infinity), '');
    assert.strictEqual(at('\uD834abc', -1), '');
    assert.strictEqual(at('\uD834abc', -0), '\uD834');
    assert.strictEqual(at('\uD834abc', 0), '\uD834');
    assert.strictEqual(at('\uD834abc', 1), 'a');
    assert.strictEqual(at('\uD834abc', 42), '');
    assert.strictEqual(at('\uD834abc', Infinity), '');
    assert.strictEqual(at('\uD834abc', null), '\uD834');
    assert.strictEqual(at('\uD834abc', void 8), '\uD834');
    assert.strictEqual(at('\uD834abc'), '\uD834');
    assert.strictEqual(at('\uD834abc', false), '\uD834');
    assert.strictEqual(at('\uD834abc', NaN), '\uD834');
    assert.strictEqual(at('\uD834abc', ''), '\uD834');
    assert.strictEqual(at('\uD834abc', '_'), '\uD834');
    assert.strictEqual(at('\uD834abc', '1'), 'a');
    assert.strictEqual(at('\uDF06abc', -Infinity), '');
    assert.strictEqual(at('\uDF06abc', -1), '');
    assert.strictEqual(at('\uDF06abc', -0), '\uDF06');
    assert.strictEqual(at('\uDF06abc', 0), '\uDF06');
    assert.strictEqual(at('\uDF06abc', 1), 'a');
    assert.strictEqual(at('\uDF06abc', 42), '');
    assert.strictEqual(at('\uDF06abc', Infinity), '');
    assert.strictEqual(at('\uDF06abc', null), '\uDF06');
    assert.strictEqual(at('\uDF06abc', void 8), '\uDF06');
    assert.strictEqual(at('\uDF06abc'), '\uDF06');
    assert.strictEqual(at('\uDF06abc', false), '\uDF06');
    assert.strictEqual(at('\uDF06abc', NaN), '\uDF06');
    assert.strictEqual(at('\uDF06abc', ''), '\uDF06');
    assert.strictEqual(at('\uDF06abc', '_'), '\uDF06');
    assert.strictEqual(at('\uDF06abc', '1'), 'a');
    assert.strictEqual(at(42, 0), '4');
    assert.strictEqual(at(42, 1), '2');
    assert.strictEqual(at({
      toString: function(){
        return 'abc';
      }
    }, 2), 'c');
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return at(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return at(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  test('String#padLeft', function(assert){
    var padLeft;
    padLeft = core.String.padLeft;
    assert.ok(toString$.call(padLeft).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(padLeft('abc', 5), '  abc');
    assert.strictEqual(padLeft('abc', 4, 'de'), 'dabc');
    assert.strictEqual(padLeft('abc'), 'abc');
    assert.strictEqual(padLeft('abc', 5, '_'), '__abc');
    assert.strictEqual(padLeft('', 0), '');
    assert.strictEqual(padLeft('foo', 1), 'foo');
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return padLeft(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return padLeft(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  test('String#padRight', function(assert){
    var padRight;
    padRight = core.String.padRight;
    assert.ok(toString$.call(padRight).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(padRight('abc', 5), 'abc  ');
    assert.strictEqual(padRight('abc', 4, 'de'), 'abcd');
    assert.strictEqual(padRight('abc'), 'abc');
    assert.strictEqual(padRight('abc', 5, '_'), 'abc__');
    assert.strictEqual(padRight('', 0), '');
    assert.strictEqual(padRight('foo', 1), 'foo');
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return padRight(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return padRight(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  test('String#trimLeft', function(assert){
    var trimLeft;
    trimLeft = core.String.trimLeft;
    assert.ok(toString$.call(trimLeft).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(trimLeft(' \n  q w e \n  '), 'q w e \n  ', 'removes whitespaces at left side of string');
    assert.strictEqual(trimLeft('\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF'), '', 'removes all whitespaces');
    assert.strictEqual(trimLeft('\u200b\u0085'), '\u200b\u0085', "shouldn't remove this symbols");
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return trimLeft(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return trimLeft(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  'use strict';
  var module, test, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('ES7');
  test('String#trimRight', function(assert){
    var trimRight;
    trimRight = core.String.trimRight;
    assert.ok(toString$.call(trimRight).slice(8, -1) === 'Function', 'is function');
    assert.strictEqual(trimRight(' \n  q w e \n  '), ' \n  q w e', 'removes whitespaces at right side of string');
    assert.strictEqual(trimRight('\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF'), '', 'removes all whitespaces');
    assert.strictEqual(trimRight('\u200b\u0085'), '\u200b\u0085', "shouldn't remove this symbols");
    if (!function(){
      return this;
    }()) {
      assert.throws(function(){
        return trimRight(null, 0);
      }, TypeError);
      return assert.throws(function(){
        return trimRight(void 8, 0);
      }, TypeError);
    }
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, slice, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('Mozilla JavaScript Array statics');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  slice = Array.prototype.slice;
  test('are functions', function(assert){
    var i$, x$, ref$, len$, results$ = [];
    for (i$ = 0, len$ = (ref$ = ['concat', 'join', 'pop', 'push', 'reverse', 'shift', 'slice', 'sort', 'splice', 'unshift', 'indexOf', 'lastIndexOf', 'every', 'some', 'forEach', 'map', 'filter', 'reduce', 'reduceRight', 'copyWithin', 'fill', 'find', 'findIndex', 'keys', 'values', 'entries', 'includes']).length; i$ < len$; ++i$) {
      x$ = ref$[i$];
      results$.push(assert.ok(isFunction(core.Array[x$]), "Array." + x$ + " is function"));
    }
    return results$;
  });
  test('.join', function(assert){
    var join;
    join = core.Array.join;
    assert.strictEqual(join('123'), '1,2,3');
    assert.strictEqual(join('123', '|'), '1|2|3');
    return assert.strictEqual(join(function(){
      return arguments;
    }(3, 2, 1), '|'), '3|2|1');
  });
  test('.pop', function(assert){
    var pop, args;
    pop = core.Array.pop;
    assert.ok(pop(args = {
      0: 1,
      1: 2,
      2: 3,
      length: 3
    }) === 3);
    return assert.deepEqual(args, {
      0: 1,
      1: 2,
      length: 2
    });
  });
  test('.push', function(assert){
    var push, args;
    push = core.Array.push;
    push(args = function(){
      return arguments;
    }(1, 2, 3), 4, 5);
    return assert.deepEqual(slice.call(args), [1, 2, 3, 4, 5]);
  });
  test('.reverse', function(assert){
    var reverse;
    reverse = core.Array.reverse;
    return assert.deepEqual(reverse(function(){
      return arguments;
    }(1, 2, 3)), function(){
      return arguments;
    }(3, 2, 1));
  });
  test('.shift', function(assert){
    var shift, args;
    shift = core.Array.shift;
    assert.ok(shift(args = {
      0: 1,
      1: 2,
      2: 3,
      length: 3
    }) === 1);
    return assert.deepEqual(args, {
      0: 2,
      1: 3,
      length: 2
    });
  });
  test('.unshift', function(assert){
    var unshift, args;
    unshift = core.Array.unshift;
    unshift(args = function(){
      return arguments;
    }(1, 2, 3), 4, 5);
    return assert.deepEqual(slice.call(args), [4, 5, 1, 2, 3]);
  });
  test('.slice', function(assert){
    var slice;
    slice = core.Array.slice;
    assert.deepEqual(slice('123'), ['1', '2', '3']);
    assert.deepEqual(slice('123', 1), ['2', '3']);
    assert.deepEqual(slice('123', 1, 2), ['2']);
    assert.deepEqual(slice('123', 1, -1), ['2']);
    assert.deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3)), [1, 2, 3]);
    assert.deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3), 1), [2, 3]);
    assert.deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3), 1, 2), [2]);
    return assert.deepEqual(slice(function(){
      return arguments;
    }(1, 2, 3), 1, -1), [2]);
  });
  test('.splice', function(assert){
    var splice, args;
    splice = core.Array.splice;
    splice(args = function(){
      return arguments;
    }(1, 2, 3), 1, 0, 4, 5);
    assert.deepEqual(slice.call(args), [1, 4, 5, 2, 3]);
    splice(args = function(){
      return arguments;
    }(1, 2, 3), 1, 1, 4);
    assert.deepEqual(slice.call(args), [1, 4, 3]);
    splice(args = function(){
      return arguments;
    }(1, 2, 3), 1, 1);
    return assert.deepEqual(slice.call(args), [1, 3]);
  });
  test('.sort', function(assert){
    var sort;
    sort = core.Array.sort;
    assert.deepEqual(sort(function(){
      return arguments;
    }(2, 1, 3)), function(){
      return arguments;
    }(1, 2, 3));
    assert.deepEqual(sort(function(){
      return arguments;
    }(11, 2, 3)), function(){
      return arguments;
    }(11, 2, 3));
    return assert.deepEqual(sort(function(){
      return arguments;
    }(11, 2, 3), function(a, b){
      return a - b;
    }), function(){
      return arguments;
    }(2, 3, 11));
  });
  test('.indexOf', function(assert){
    var indexOf;
    indexOf = core.Array.indexOf;
    assert.ok(indexOf('111', '1') === 0);
    assert.ok(indexOf('123', '1', 1) === -1);
    assert.ok(indexOf('123', '2', 1) === 1);
    assert.ok(indexOf(function(){
      return arguments;
    }(1, 1, 1), 1) === 0);
    assert.ok(indexOf(function(){
      return arguments;
    }(1, 2, 3), 1, 1) === -1);
    return assert.ok(indexOf(function(){
      return arguments;
    }(1, 2, 3), 2, 1) === 1);
  });
  test('.lastIndexOf', function(assert){
    var lastIndexOf;
    lastIndexOf = core.Array.lastIndexOf;
    assert.ok(lastIndexOf('111', '1') === 2);
    assert.ok(lastIndexOf('123', '3', 1) === -1);
    assert.ok(lastIndexOf('123', '2', 1) === 1);
    assert.ok(lastIndexOf(function(){
      return arguments;
    }(1, 1, 1), 1) === 2);
    assert.ok(lastIndexOf(function(){
      return arguments;
    }(1, 2, 3), 3, 1) === -1);
    return assert.ok(lastIndexOf(function(){
      return arguments;
    }(1, 2, 3), 2, 1) === 1);
  });
  test('.every', function(assert){
    var every, al, ctx;
    every = core.Array.every;
    every(al = function(){
      return arguments;
    }(1), function(val, key, that){
      assert.ok(this === ctx);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === al);
    }, ctx = {});
    assert.ok(every('123', function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    assert.ok(every('123', function(){
      return arguments[1] < 3;
    }));
    assert.ok(!every('123', function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    assert.ok(!every('123', function(){
      return arguments[1] < 2;
    }));
    assert.ok(every('123', function(){
      return arguments[2] == '123';
    }));
    return assert.ok(every(function(){
      return arguments;
    }(1, 2, 3), function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('.some', function(assert){
    var some, al, ctx;
    some = core.Array.some;
    some(al = function(){
      return arguments;
    }(1), function(val, key, that){
      assert.ok(this === ctx);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === al);
    }, ctx = {});
    assert.ok(some('123', function(it){
      return toString$.call(it).slice(8, -1) === 'String';
    }));
    assert.ok(some('123', function(){
      return arguments[1] > 1;
    }));
    assert.ok(!some('123', function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
    assert.ok(!some('123', function(){
      return arguments[1] > 3;
    }));
    assert.ok(some('123', function(){
      return arguments[2] == '123';
    }));
    return assert.ok(some(function(){
      return arguments;
    }(1, 2, 3), function(it){
      return toString$.call(it).slice(8, -1) === 'Number';
    }));
  });
  test('.forEach', function(assert){
    var forEach, al, ctx, val;
    forEach = core.Array.forEach;
    forEach(al = function(){
      return arguments;
    }(1), function(val, key, that){
      assert.ok(this === ctx);
      assert.ok(val === 1);
      assert.ok(key === 0);
      assert.ok(that === al);
    }, ctx = {});
    val = '';
    forEach('123', function(v, k, t){
      val += v + k + t;
    });
    assert.ok(val === '101232112332123');
    val = '';
    forEach(function(){
      return arguments;
    }(1, 2, 3), function(v, k, t){
      val += v + k + t['2'];
    });
    assert.ok(val === '468');
    val = '';
    forEach('123', function(v, k, t){
      val += v + k + t + this;
    }, 1);
    return assert.ok(val === '101231211231321231');
  });
  test('.map', function(assert){
    var map, al, ctx;
    map = core.Array.map;
    map(al = function(){
      return arguments;
    }(1), function(val, key, that){
      assert.ok(this === ctx);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === al);
    }, ctx = {});
    assert.deepEqual(map('123', (function(it){
      return Math.pow(it, 2);
    })), [1, 4, 9]);
    return assert.deepEqual(map(function(){
      return arguments;
    }(1, 2, 3), (function(it){
      return Math.pow(it, 2);
    })), [1, 4, 9]);
  });
  test('.filter', function(assert){
    var filter, al, ctx;
    filter = core.Array.filter;
    filter(al = function(){
      return arguments;
    }(1), function(val, key, that){
      assert.ok(this === ctx);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === al);
    }, ctx = {});
    assert.deepEqual(filter('123', function(it){
      return it > 1;
    }), ['2', '3']);
    assert.deepEqual(filter(function(){
      return arguments;
    }(1, 2, 3), function(it){
      return it < 3;
    }), [1, 2]);
    return assert.deepEqual(filter('123', function(){
      return arguments[1] !== 1;
    }), ['1', '3']);
  });
  test('.reduce', function(assert){
    var reduce, al, ctx;
    reduce = core.Array.reduce;
    reduce(al = function(){
      return arguments;
    }(1), function(memo, val, key, that){
      assert.ok(memo === ctx);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === al);
    }, ctx = {});
    reduce(al = function(){
      return arguments;
    }(1, 2), function(memo){
      return assert.ok(memo === 1);
    });
    assert.ok(reduce('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }) === 6);
    assert.ok(reduce(function(){
      return arguments;
    }(1, 2, 3), function(a, b){
      return '' + b * b + a;
    }) === '941');
    return assert.ok(reduce('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }, 1) === 7);
  });
  test('.reduceRight', function(assert){
    var reduceRight, al, ctx;
    reduceRight = core.Array.reduceRight;
    reduceRight(al = function(){
      return arguments;
    }(1), function(memo, val, key, that){
      assert.ok(memo === ctx);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === al);
    }, ctx = {});
    reduceRight(al = function(){
      return arguments;
    }(1, 2), function(memo){
      return assert.ok(memo === 2);
    });
    assert.ok(reduceRight('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }) === 6);
    assert.ok(reduceRight(function(){
      return arguments;
    }(1, 2, 3), function(a, b){
      return '' + b * b + a;
    }) === '143');
    return assert.ok(reduceRight('123', function(a, b){
      a = +a;
      b = +b;
      return a + b;
    }, 1) === 7);
  });
  test('.copyWithin', function(assert){
    var copyWithin, a;
    copyWithin = core.Array.copyWithin;
    assert.ok(copyWithin(a = function(){
      return arguments;
    }(1, 2, 3), 0) === a);
    assert.deepEqual(copyWithin(function(){
      return arguments;
    }(1, 2, 3), -2), function(){
      return arguments;
    }(1, 1, 2));
    assert.deepEqual(copyWithin(function(){
      return arguments;
    }(1, 2, 3), 0, 1), function(){
      return arguments;
    }(2, 3, 3));
    return assert.deepEqual(copyWithin(function(){
      return arguments;
    }(1, 2, 3), 0, 1, 2), function(){
      return arguments;
    }(2, 2, 3));
  });
  test('.fill', function(assert){
    var fill, a;
    fill = core.Array.fill;
    assert.ok(fill(a = function(){
      return arguments;
    }(1, 2, 3), 0) === a);
    return assert.deepEqual(fill(Array(3), 5), [5, 5, 5]);
  });
  test('.find', function(assert){
    var find, al, ctx;
    find = core.Array.find;
    find(al = function(){
      return arguments;
    }(1), function(val, key, that){
      assert.ok(this === ctx);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === al);
    }, ctx = {});
    assert.ok(find(function(){
      return arguments;
    }(1, 3, NaN, 42, {}), (function(it){
      return it === 42;
    })) === 42);
    assert.ok(find('123', (function(it){
      return it === '2';
    })) === '2');
    return assert.ok(find('123', (function(it){
      return it === '4';
    })) === void 8);
  });
  test('.findIndex', function(assert){
    var findIndex, al, ctx;
    findIndex = core.Array.findIndex;
    findIndex(al = function(){
      return arguments;
    }(1), function(val, key, that){
      assert.ok(this === ctx);
      assert.ok(val === 1);
      assert.ok(key === 0);
      return assert.ok(that === al);
    }, ctx = {});
    assert.ok(findIndex(function(){
      return arguments;
    }(1, 3, NaN, 42, {}), (function(it){
      return it === 42;
    })) === 3);
    assert.ok(findIndex('123', (function(it){
      return it === '2';
    })) === 1);
    return assert.ok(findIndex('123', (function(it){
      return it === '4';
    })) === -1);
  });
  test('.keys', function(assert){
    var keys, iter1, iter2;
    keys = core.Array.keys;
    assert.ok(typeof keys === 'function', 'is function');
    iter1 = keys(function(){
      return arguments;
    }('q', 'w', 'e'));
    assert.ok(typeof iter1 === 'object', 'Iterator is object');
    assert.ok(typeof iter1.next === 'function', 'Iterator has .next method');
    assert.deepEqual(iter1.next(), {
      value: 0,
      done: false
    });
    assert.deepEqual(iter1.next(), {
      value: 1,
      done: false
    });
    assert.deepEqual(iter1.next(), {
      value: 2,
      done: false
    });
    assert.deepEqual(iter1.next(), {
      value: void 8,
      done: true
    });
    iter2 = keys('qwe');
    assert.deepEqual(iter2.next(), {
      value: 0,
      done: false
    });
    assert.deepEqual(iter2.next(), {
      value: 1,
      done: false
    });
    assert.deepEqual(iter2.next(), {
      value: 2,
      done: false
    });
    return assert.deepEqual(iter2.next(), {
      value: void 8,
      done: true
    });
  });
  test('.values', function(assert){
    var values, iter1, iter2;
    values = core.Array.values;
    assert.ok(typeof values === 'function', 'is function');
    iter1 = values(function(){
      return arguments;
    }('q', 'w', 'e'));
    assert.ok(typeof iter1 === 'object', 'Iterator is object');
    assert.ok(typeof iter1.next === 'function', 'Iterator has .next method');
    assert.deepEqual(iter1.next(), {
      value: 'q',
      done: false
    });
    assert.deepEqual(iter1.next(), {
      value: 'w',
      done: false
    });
    assert.deepEqual(iter1.next(), {
      value: 'e',
      done: false
    });
    assert.deepEqual(iter1.next(), {
      value: void 8,
      done: true
    });
    iter2 = values('qwe');
    assert.deepEqual(iter2.next(), {
      value: 'q',
      done: false
    });
    assert.deepEqual(iter2.next(), {
      value: 'w',
      done: false
    });
    assert.deepEqual(iter2.next(), {
      value: 'e',
      done: false
    });
    return assert.deepEqual(iter2.next(), {
      value: void 8,
      done: true
    });
  });
  test('.entries', function(assert){
    var entries, iter1, iter2;
    entries = core.Array.entries;
    assert.ok(typeof entries === 'function', 'is function');
    iter1 = entries(function(){
      return arguments;
    }('q', 'w', 'e'));
    assert.ok(typeof iter1 === 'object', 'Iterator is object');
    assert.ok(typeof iter1.next === 'function', 'Iterator has .next method');
    assert.deepEqual(iter1.next(), {
      value: [0, 'q'],
      done: false
    });
    assert.deepEqual(iter1.next(), {
      value: [1, 'w'],
      done: false
    });
    assert.deepEqual(iter1.next(), {
      value: [2, 'e'],
      done: false
    });
    assert.deepEqual(iter1.next(), {
      value: void 8,
      done: true
    });
    iter2 = entries('qwe');
    assert.deepEqual(iter2.next(), {
      value: [0, 'q'],
      done: false
    });
    assert.deepEqual(iter2.next(), {
      value: [1, 'w'],
      done: false
    });
    assert.deepEqual(iter2.next(), {
      value: [2, 'e'],
      done: false
    });
    return assert.deepEqual(iter2.next(), {
      value: void 8,
      done: true
    });
  });
  test('.includes', function(assert){
    var includes, args, o, str;
    includes = core.Array.includes;
    assert.ok(isFunction(includes), 'is function');
    args = function(){
      return arguments;
    }(1, 2, 3, -0, NaN, o = {});
    assert.ok(includes(args, 1));
    assert.ok(includes(args, -0));
    assert.ok(includes(args, 0));
    assert.ok(includes(args, NaN));
    assert.ok(includes(args, o));
    assert.ok(!includes(args, 4));
    assert.ok(!includes(args, -0.5));
    assert.ok(!includes(args, {}));
    str = 'qwe';
    assert.ok(includes(str, 'q'));
    return assert.ok(!includes(str, 'r'));
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('DOM iterable');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  if ((typeof NodeList != 'undefined' && NodeList !== null) && ((typeof document != 'undefined' && document !== null) && document.querySelectorAll) && toString$.call(document.querySelectorAll('div')).slice(8, -1) === 'NodeList') {
    test('NodeList.prototype@@iterator', function(assert){
      return assert.ok(core.isIterable(document.querySelectorAll('div')), 'Is iterable');
    });
  }
  if ((typeof HTMLCollection != 'undefined' && HTMLCollection !== null) && ((typeof document != 'undefined' && document !== null) && document.getElementsByTagName) && toString$.call(document.getElementsByTagName('div')).slice(8, -1) === 'HTMLCollection') {
    test('HTMLCollection.prototype@@iterator', function(assert){
      return assert.ok(core.isIterable(document.getElementsByTagName('div')), 'Is iterable');
    });
  }
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, isFunction, timeLimitedPromise, setImmediate, clearImmediate, Promise, toString$ = {}.toString;
  module = QUnit.module, test = QUnit.test;
  module('Immediate');
  isFunction = function(it){
    return toString$.call(it).slice(8, -1) === 'Function';
  };
  timeLimitedPromise = function(time, fn){
    return Promise.race([
      new Promise(fn), new Promise(function(res, rej){
        return setTimeout(rej, time);
      })
    ]);
  };
  setImmediate = core.setImmediate, clearImmediate = core.clearImmediate, Promise = core.Promise;
  test('setImmediate / clearImmediate', function(assert){
    var def;
    assert.expect(6);
    assert.ok(isFunction(setImmediate), 'setImmediate is function');
    assert.ok(isFunction(clearImmediate), 'clearImmediate is function');
    timeLimitedPromise(1e3, function(res){
      return setImmediate(function(){
        def = 'a';
        return res();
      });
    }).then(function(){
      return assert.ok(true, 'setImmediate works');
    })['catch'](function(){
      return assert.ok(false, 'setImmediate works');
    }).then(assert.async());
    assert.strictEqual(def, void 8, 'setImmediate is async');
    timeLimitedPromise(1e3, function(res){
      return setImmediate(function(a, b){
        return res(a + b);
      }, 'a', 'b');
    }).then(function(it){
      return assert.strictEqual(it, 'ab', 'setImmediate works with additional args');
    })['catch'](function(){
      return assert.ok(false, 'setImmediate works with additional args');
    }).then(assert.async());
    return timeLimitedPromise(50, function(res){
      return clearImmediate(setImmediate(res));
    }).then(function(){
      return assert.ok(false, 'clearImmediate works');
    })['catch'](function(){
      return assert.ok(true, 'clearImmediate works');
    }).then(assert.async());
  });
  (function(it){
    if (typeof window != 'undefined' && window !== null) {
      return window.onload = it;
    } else {
      return it();
    }
  })(function(){
    return setTimeout(function(){
      var x, now, inc;
      x = 0;
      now = +new Date;
      return (inc = function(){
        return setImmediate(function(){
          x = x + 1;
          if (+new Date() - now < 5e3) {
            return inc();
          } else {
            return typeof console != 'undefined' && console !== null ? console.log("setImmediate: " + x / 5 + " per second") : void 8;
          }
        });
      })();
    }, 5e3);
  });
}).call(this);

// Generated by LiveScript 1.3.1
(function(){
  var module, test, setTimeout, setInterval, Promise, timeLimitedPromise;
  module = QUnit.module, test = QUnit.test;
  module('Timers');
  setTimeout = core.setTimeout, setInterval = core.setInterval, Promise = core.Promise;
  timeLimitedPromise = function(time, fn){
    return Promise.race([
      new Promise(fn), new Promise(function(res, rej){
        return setTimeout(rej, time);
      })
    ]);
  };
  test('setTimeout / clearTimeout', function(assert){
    assert.expect(2);
    timeLimitedPromise(1e3, function(res){
      return setTimeout(function(a, b){
        return res(a + b);
      }, 10, 'a', 'b');
    }).then(function(it){
      return assert.strictEqual(it, 'ab', 'setTimeout works with additional args');
    })['catch'](function(){
      return assert.ok(false, 'setTimeout works with additional args');
    }).then(assert.async());
    return timeLimitedPromise(50, function(res){
      return clearTimeout(setTimeout(res, 10));
    }).then(function(){
      return assert.ok(false, 'clearImmediate works with wraped setTimeout');
    })['catch'](function(){
      return assert.ok(true, 'clearImmediate works with wraped setTimeout');
    }).then(assert.async());
  });
  test('setInterval / clearInterval', function(assert){
    var i;
    assert.expect(1);
    i = 0;
    return timeLimitedPromise(1e4, function(res, rej){
      var interval;
      return interval = setInterval(function(a, b){
        if (a + b !== 'ab' || i > 2) {
          rej({
            a: a,
            b: b,
            i: i
          });
        }
        if (i++ === 2) {
          clearInterval(interval);
          return setTimeout(res, 30);
        }
      }, 5, 'a', 'b');
    }).then(function(){
      return assert.ok(true, 'setInterval & clearInterval works with additional args');
    })['catch'](function(arg$){
      var ref$, a, b, i;
      ref$ = arg$ != null
        ? arg$
        : {}, a = ref$.a, b = ref$.b, i = ref$.i;
      return assert.ok(false, "setInterval & clearInterval works with additional args: " + a + ", " + b + ", times: " + i);
    }).then(assert.async());
  });
}).call(this);
